/* Process model C form file: LLE_process.pr.c */
/* Portions of this file copyright 1992-2002 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
static const char LLE_process_pr_c [] = "MIL_3_Tfile_Hdr_ 90A 30A opnet 7 3E53EA43 3E53EA43 1 payette mjohanss 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                       ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

/* incoming stream macros */
#define LLME_TO_LLE1		0
#define MUX_TO_LLE1			1
#define UPPERLAYER_TO_LLE1	2

/* outgoing stream macros */
#define LLE1_TO_MUX			0 
#define LLE1_TO_UPPERLAYER	1


/* transition macros */
#define PACKET_FROM_LLME (op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () == LLME_TO_LLE1)
#define PACKET_FROM_MUX (op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () == MUX_TO_LLE1)
#define PACKET_FROM_SNDCP (op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () == UPPERLAYER_TO_LLE1)



/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	} LLE_process_state;

#define pr_state_ptr            		((LLE_process_state*) SimI_Mod_State_Ptr)

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	LLE_process_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void LLE_process (void);
	Compcode LLE_process_init (void **);
	void LLE_process_diag (void);
	void LLE_process_terminate (void);
	void LLE_process_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
LLE_process (void)
	{
	int _block_origin = 0;
	FIN (LLE_process ());
	if (1)
		{


		FSM_ENTER (LLE_process)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "init", "LLE_process [init enter execs]")
				FSM_PROFILE_SECTION_IN ("LLE_process [init enter execs]", state0_enter_exec)
				{
				}

				FSM_PROFILE_SECTION_OUT ("LLE_process [init enter execs]", state0_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "init", "LLE_process [init exit execs]")
				FSM_PROFILE_SECTION_IN ("LLE_process [init exit execs]", state0_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("LLE_process [init exit execs]", state0_exit_exec)


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "init", "idle")
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "idle", "LLE_process [idle enter execs]")
				FSM_PROFILE_SECTION_IN ("LLE_process [idle enter execs]", state1_enter_exec)
				{
				}

				FSM_PROFILE_SECTION_OUT ("LLE_process [idle enter execs]", state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,LLE_process)


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "idle", "LLE_process [idle exit execs]")
				FSM_PROFILE_SECTION_IN ("LLE_process [idle exit execs]", state1_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("LLE_process [idle exit execs]", state1_exit_exec)


			/** state (idle) transition processing **/
			FSM_PROFILE_SECTION_IN ("LLE_process [idle trans conditions]", state1_trans_conds)
			FSM_INIT_COND (PACKET_FROM_LLME)
			FSM_TEST_COND (PACKET_FROM_SNDCP)
			FSM_TEST_COND (PACKET_FROM_MUX)
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT ("LLE_process [idle trans conditions]", state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;, "PACKET_FROM_LLME", "", "idle", "TLLI_ADM")
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;, "PACKET_FROM_SNDCP", "", "idle", "st_3")
				FSM_CASE_TRANSIT (2, 4, state4_enter_exec, ;, "PACKET_FROM_MUX", "", "idle", "st_4")
				}
				/*---------------------------------------------------------*/



			/** state (TLLI_ADM) enter executives **/
			FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "TLLI_ADM", "LLE_process [TLLI_ADM enter execs]")
				FSM_PROFILE_SECTION_IN ("LLE_process [TLLI_ADM enter execs]", state2_enter_exec)
				{
				}

				FSM_PROFILE_SECTION_OUT ("LLE_process [TLLI_ADM enter execs]", state2_enter_exec)

			/** state (TLLI_ADM) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "TLLI_ADM", "LLE_process [TLLI_ADM exit execs]")
				FSM_PROFILE_SECTION_IN ("LLE_process [TLLI_ADM exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("LLE_process [TLLI_ADM exit execs]", state2_exit_exec)


			/** state (TLLI_ADM) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "TLLI_ADM", "idle")
				/*---------------------------------------------------------*/



			/** state (st_3) enter executives **/
			FSM_STATE_ENTER_FORCED (3, state3_enter_exec, "st_3", "LLE_process [st_3 enter execs]")
				FSM_PROFILE_SECTION_IN ("LLE_process [st_3 enter execs]", state3_enter_exec)
				{
				}

				FSM_PROFILE_SECTION_OUT ("LLE_process [st_3 enter execs]", state3_enter_exec)

			/** state (st_3) exit executives **/
			FSM_STATE_EXIT_FORCED (3, "st_3", "LLE_process [st_3 exit execs]")
				FSM_PROFILE_SECTION_IN ("LLE_process [st_3 exit execs]", state3_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("LLE_process [st_3 exit execs]", state3_exit_exec)


			/** state (st_3) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "st_3", "idle")
				/*---------------------------------------------------------*/



			/** state (st_4) enter executives **/
			FSM_STATE_ENTER_FORCED (4, state4_enter_exec, "st_4", "LLE_process [st_4 enter execs]")
				FSM_PROFILE_SECTION_IN ("LLE_process [st_4 enter execs]", state4_enter_exec)
				{
				}

				FSM_PROFILE_SECTION_OUT ("LLE_process [st_4 enter execs]", state4_enter_exec)

			/** state (st_4) exit executives **/
			FSM_STATE_EXIT_FORCED (4, "st_4", "LLE_process [st_4 exit execs]")
				FSM_PROFILE_SECTION_IN ("LLE_process [st_4 exit execs]", state4_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT ("LLE_process [st_4 exit execs]", state4_exit_exec)


			/** state (st_4) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "st_4", "idle")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,LLE_process)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
LLE_process_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (LLE_process_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (LLE_process)",
			sizeof (LLE_process_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((LLE_process_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
LLE_process_diag (void)
	{
	/* No Diagnostic Block */
	}




void
LLE_process_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (LLE_process_terminate (void))

	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT
	}




void
LLE_process_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{

	FIN (LLE_process_svar (gen_ptr, var_name, var_p_ptr))

	*var_p_ptr = (char *)OPC_NIL;

	FOUT
	}

