/* Process model C form file: LLME_process.pr.c */
/* Portions of this file copyright 1992-2003 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
const char LLME_process_pr_c [] = "MIL_3_Tfile_Hdr_ 100A 30A op_runsim 7 40E36437 40E36437 1 hermes rsn 0 0 none none 0 0 none 0 0 0 0 0 0 0 0 90b 2                                                                                                                                                                                                                                                                                                                                                                                                              ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>



/* Header Block */

#include "gprs_llc.h"


/* incoming stream macros */
#define UPPERLAYER_TO_LLME	0
/* outgoing stream macros */  
#define LLME_TO_LLE1		0  
#define LLME_TO_LLE3		1 
#define LLME_TO_UPPERLAYER	2

/* transition macros */
#define PACKET_FROM_UPPERLAYER (op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () == UPPERLAYER_TO_LLME)




/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(_op_last_line_passed) = __LINE__ - _op_block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(_op_last_line_passed) = 0; _op_block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	imsi_record	            		LLME_imsi_records[MAX_SUPPORTED_MS];
	} LLME_process_state;

#define pr_state_ptr            		((LLME_process_state*) (OP_SIM_CONTEXT_PTR->mod_state_ptr))
#define LLME_imsi_records       		pr_state_ptr->LLME_imsi_records

/* These macro definitions will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE
#if defined (OPD_PARALLEL)
#  define FIN_PREAMBLE_DEC	LLME_process_state *op_sv_ptr; OpT_Sim_Context * tcontext_ptr;
#  define FIN_PREAMBLE_CODE	\
		if (VosS_Mt_Perform_Lock) \
			VOS_THREAD_SPECIFIC_DATA_GET (VosI_Globals.simi_mt_context_data_key, tcontext_ptr, SimT_Context *); \
		else \
			tcontext_ptr = VosI_Globals.simi_sequential_context_ptr; \
		op_sv_ptr = ((LLME_process_state *)(tcontext_ptr->mod_state_ptr));
#else
#  define FIN_PREAMBLE_DEC	LLME_process_state *op_sv_ptr;
#  define FIN_PREAMBLE_CODE	op_sv_ptr = pr_state_ptr;
#endif


/* Function Block */


#if !defined (VOSD_NO_FIN)
enum { _op_block_origin = __LINE__ };
#endif
static Packet* generate (char packet_type[30])
	{
	Packet*				pkptr;
	double				pksize;
   
	FIN (generate ());

	
	/* Create a formatted packet */
	pkptr = op_pk_create_fmt (packet_type);
	
	
	FRET (pkptr);

	}	

/* End of Function Block */

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void LLME_process (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Obtype LLME_process_init (int * init_block_ptr);
	VosT_Address LLME_process_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype, int);
	void LLME_process_diag (OP_SIM_CONTEXT_ARG_OPT);
	void LLME_process_terminate (OP_SIM_CONTEXT_ARG_OPT);
	void LLME_process_svar (void *, const char *, void **);


	VosT_Fun_Status Vos_Define_Object (VosT_Obtype * _op_obst_ptr, const char * _op_name, unsigned int _op_size, unsigned int _op_init_obs, unsigned int _op_inc_obs);
	VosT_Address Vos_Alloc_Object_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype _op_ob_hndl);
	VosT_Fun_Status Vos_Poolmem_Dealloc_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Address _op_ob_ptr);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
LLME_process (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	FIN_MT (LLME_process ());
	if (1)
		{


		FSM_ENTER ("LLME_process")

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "init", "LLME_process [init enter execs]")
				FSM_PROFILE_SECTION_IN ("LLME_process [init enter execs]", state0_enter_exec)
				{
				// initialize the state variables for each MS (imsi).
				int i;
				
				for (i=0; i < MAX_SUPPORTED_MS; i++)
					{
					    LLME_imsi_records[i].imsi = i; //imsi and tlli are the same in this impl.
						LLME_imsi_records[i].tlli_new = 0; 
						LLME_imsi_records[i].tlli_old = 0;
						LLME_imsi_records[i].state = TLLI_UNASSIGNED;
					} 
				
				}
				FSM_PROFILE_SECTION_OUT (state0_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "init", "LLME_process [init exit execs]")
				FSM_PROFILE_SECTION_IN ("LLME_process [init exit execs]", state0_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state0_exit_exec)


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "init", "idle")
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, "idle", state1_enter_exec, "LLME_process [idle enter execs]")
				FSM_PROFILE_SECTION_IN ("LLME_process [idle enter execs]", state1_enter_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,"LLME_process")


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "idle", "LLME_process [idle exit execs]")
				FSM_PROFILE_SECTION_IN ("LLME_process [idle exit execs]", state1_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state1_exit_exec)


			/** state (idle) transition processing **/
			FSM_PROFILE_SECTION_IN ("LLME_process [idle trans conditions]", state1_trans_conds)
			FSM_INIT_COND (PACKET_FROM_UPPERLAYER)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT (state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;, "PACKET_FROM_UPPERLAYER", "", "idle", "rec")
				FSM_CASE_TRANSIT (1, 1, state1_enter_exec, ;, "default", "", "idle", "idle")
				}
				/*---------------------------------------------------------*/



			/** state (rec) enter executives **/
			FSM_STATE_ENTER_FORCED (2, "rec", state2_enter_exec, "LLME_process [rec enter execs]")
				FSM_PROFILE_SECTION_IN ("LLME_process [rec enter execs]", state2_enter_exec)
				{
				Packet* in_packet_ptr;
				Packet* out_packet_ptr;
				int message_type; 
				int result;
				int tlli_old, tlli_new, imsi;
				
					
				/* Get a pointer to received packet*/
				in_packet_ptr = op_pk_get (op_intrpt_strm());
				
				result=op_pk_nfd_get(in_packet_ptr, "message_type", &message_type);
				
				// Check message type and act accordingly
				switch (message_type) {
				    
					case gprs_LLGMM_ASSIGN_REQ:
					
					// TLLI assignment for a certain cell-phone (imsi). Update
					// state for imsi in LLME and create and send packet to each LLE:s to set ADM state for 
				    // current imsi in LLE1 and LLE3.
					
					//Extract values from packet	
					result=op_pk_nfd_get(in_packet_ptr,"tlli_old", &tlli_old);
					result=op_pk_nfd_get(in_packet_ptr,"tlli_new", &tlli_new);
					result=op_pk_nfd_get(in_packet_ptr,"imsi", &imsi);
					
					
					//Add some more intelligent code here to work with tlli_old and tlli_new according to 
					//the LLC specification. As of now, imsi and tlli are the same in this implementation why
					//tlli_old and tlli_new both are equal to imsi at all times.
					
					//Set new state for imsi in LLME
					LLME_imsi_records[imsi].state=TLLI_ASSIGNED;
					
					//Set assigned tlli-values, which in this implementation are equal to imsi
					LLME_imsi_records[imsi].tlli_new = tlli_new; 
					LLME_imsi_records[imsi].tlli_old = tlli_old;
					
					/*Create and send TLLI-assignment packet to set LLE1 in state ADM for current imsi*/
					out_packet_ptr=generate("gprs_LLME_LLE_ASSIGN");
					if (out_packet_ptr==OPC_NIL) 
						{
							printf("LLME: pkptr=NIL\n");
						}
					else
						{
							op_pk_nfd_set(out_packet_ptr, "message_type", gprs_LLME_LLE_ASSIGN); 
							op_pk_nfd_set(out_packet_ptr, "tlli_old", tlli_old);
					   		op_pk_nfd_set(out_packet_ptr, "tlli_new", tlli_new);
							op_pk_nfd_set(out_packet_ptr, "imsi", imsi);
							op_pk_send(out_packet_ptr, LLME_TO_LLE1);
						}
					
					/*Create and send TLLI-assignment packet to set LLE3 in state ADM for current imsi*/
					out_packet_ptr=generate("gprs_LLME_LLE_ASSIGN");
					if (out_packet_ptr==OPC_NIL) 
						{
							printf("LLME: pkptr=NIL\n");
						}
					else
						{
							op_pk_nfd_set(out_packet_ptr, "message_type", gprs_LLME_LLE_ASSIGN); 
							op_pk_nfd_set(out_packet_ptr, "tlli_old", tlli_old);
					   		op_pk_nfd_set(out_packet_ptr, "tlli_new", tlli_new);
							op_pk_nfd_set(out_packet_ptr, "imsi", imsi);
							op_pk_send(out_packet_ptr, LLME_TO_LLE3);
						}
				
					
				    	break;
					
				    default:
					    break;
					   }
				
				/*destroy the incoming packet*/	
				op_pk_destroy (in_packet_ptr);
				
				
				
				}
				FSM_PROFILE_SECTION_OUT (state2_enter_exec)

			/** state (rec) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "rec", "LLME_process [rec exit execs]")
				FSM_PROFILE_SECTION_IN ("LLME_process [rec exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state2_exit_exec)


			/** state (rec) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "rec", "idle")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,"LLME_process")
		}
	}




void
LLME_process_diag (OP_SIM_CONTEXT_ARG_OPT)
	{
	/* No Diagnostic Block */
	}




void
LLME_process_terminate (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = __LINE__;
#endif

	FIN_MT (LLME_process_terminate ())

	Vos_Poolmem_Dealloc_MT (OP_SIM_CONTEXT_THREAD_INDEX_COMMA pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in LLME_process_svar function. */
#undef LLME_imsi_records

#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE

#define FIN_PREAMBLE_DEC
#define FIN_PREAMBLE_CODE

VosT_Obtype
LLME_process_init (int * init_block_ptr)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	VosT_Obtype obtype = OPC_NIL;
	FIN_MT (LLME_process_init (init_block_ptr))

	Vos_Define_Object (&obtype, "proc state vars (LLME_process)",
		sizeof (LLME_process_state), 0, 20);
	*init_block_ptr = 0;

	FRET (obtype)
	}

VosT_Address
LLME_process_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype obtype, int init_block)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	LLME_process_state * ptr;
	FIN_MT (LLME_process_alloc (obtype))

	ptr = (LLME_process_state *)Vos_Alloc_Object_MT (VOS_THREAD_INDEX_COMMA obtype);
	if (ptr != OPC_NIL)
		ptr->_op_current_block = init_block;
	FRET ((VosT_Address)ptr)
	}



void
LLME_process_svar (void * gen_ptr, const char * var_name, void ** var_p_ptr)
	{
	LLME_process_state		*prs_ptr;

	FIN_MT (LLME_process_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (void *)OPC_NIL;
		FOUT
		}
	prs_ptr = (LLME_process_state *)gen_ptr;

	if (strcmp ("LLME_imsi_records" , var_name) == 0)
		{
		*var_p_ptr = (void *) (prs_ptr->LLME_imsi_records);
		FOUT
		}
	*var_p_ptr = (void *)OPC_NIL;

	FOUT
	}

