/* Process model C form file: Power_monitor.pr.c */
/* Portions of this file copyright 1992-2003 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
const char Power_monitor_pr_c [] = "MIL_3_Tfile_Hdr_ 100A 30A op_runsim 7 40E364C2 40E364C2 1 hermes rsn 0 0 none none 0 0 none 0 0 0 0 0 0 0 0 90b 2                                                                                                                                                                                                                                                                                                                                                                                                              ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>



/* Header Block */

/*Header block contains definition of stream and transition macros 
and an external declaration for the global variable msStatus.*/
#include "msRecord.h"

//incoming stream macros
#define LOWERLAYER_TO_POWER_MONITOR	6

//outgoing stream macros
#define POWER_MONITOR_TO_TX			0

//transition macros
#define POWER_STAT_RECEIVED	(op_intrpt_type () == OPC_INTRPT_STAT)
#define PACKET_RECEIVED	(op_intrpt_type () == OPC_INTRPT_STRM)

//structure to store the mobile station status info
//declared in msprocess model
//defined in msRecord.h
extern MSStatus msStatus[MAX_SUPPORTED_MS];

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(_op_last_line_passed) = __LINE__ - _op_block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(_op_last_line_passed) = 0; _op_block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	Stathandle	             		bits_rcvd_stathandle;
	Stathandle	             		bitssec_rcvd_stathandle;
	Stathandle	             		pkts_rcvd_stathandle;
	Stathandle	             		pktssec_rcvd_stathandle;
	Stathandle	             		ete_delay_stathandle;
	Stathandle	             		bits_rcvd_gstathandle;
	Stathandle	             		bitssec_rcvd_gstathandle;
	Stathandle	             		pkts_rcvd_gstathandle;
	Stathandle	             		pktssec_rcvd_gstathandle;
	Stathandle	             		ete_delay_gstathandle;
	double	                 		power_table[6];
	double	                 		next_measurement_time;
	double	                 		measurement_interval;
	int	                    		best_channel;
	Objid	                  		tx_ch_object_id;
	Objid	                  		rx_ch_object_id;
	int	                    		imsi;
	int	                    		tlli;
	} Power_monitor_state;

#define pr_state_ptr            		((Power_monitor_state*) (OP_SIM_CONTEXT_PTR->mod_state_ptr))
#define bits_rcvd_stathandle    		pr_state_ptr->bits_rcvd_stathandle
#define bitssec_rcvd_stathandle 		pr_state_ptr->bitssec_rcvd_stathandle
#define pkts_rcvd_stathandle    		pr_state_ptr->pkts_rcvd_stathandle
#define pktssec_rcvd_stathandle 		pr_state_ptr->pktssec_rcvd_stathandle
#define ete_delay_stathandle    		pr_state_ptr->ete_delay_stathandle
#define bits_rcvd_gstathandle   		pr_state_ptr->bits_rcvd_gstathandle
#define bitssec_rcvd_gstathandle		pr_state_ptr->bitssec_rcvd_gstathandle
#define pkts_rcvd_gstathandle   		pr_state_ptr->pkts_rcvd_gstathandle
#define pktssec_rcvd_gstathandle		pr_state_ptr->pktssec_rcvd_gstathandle
#define ete_delay_gstathandle   		pr_state_ptr->ete_delay_gstathandle
#define power_table             		pr_state_ptr->power_table
#define next_measurement_time   		pr_state_ptr->next_measurement_time
#define measurement_interval    		pr_state_ptr->measurement_interval
#define best_channel            		pr_state_ptr->best_channel
#define tx_ch_object_id         		pr_state_ptr->tx_ch_object_id
#define rx_ch_object_id         		pr_state_ptr->rx_ch_object_id
#define imsi                    		pr_state_ptr->imsi
#define tlli                    		pr_state_ptr->tlli

/* These macro definitions will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE
#if defined (OPD_PARALLEL)
#  define FIN_PREAMBLE_DEC	Power_monitor_state *op_sv_ptr; OpT_Sim_Context * tcontext_ptr;
#  define FIN_PREAMBLE_CODE	\
		if (VosS_Mt_Perform_Lock) \
			VOS_THREAD_SPECIFIC_DATA_GET (VosI_Globals.simi_mt_context_data_key, tcontext_ptr, SimT_Context *); \
		else \
			tcontext_ptr = VosI_Globals.simi_sequential_context_ptr; \
		op_sv_ptr = ((Power_monitor_state *)(tcontext_ptr->mod_state_ptr));
#else
#  define FIN_PREAMBLE_DEC	Power_monitor_state *op_sv_ptr;
#  define FIN_PREAMBLE_CODE	op_sv_ptr = pr_state_ptr;
#endif


/* Function Block */


#if !defined (VOSD_NO_FIN)
enum { _op_block_origin = __LINE__ };
#endif
/*Function to generate a packet based on the type speciifed
in the argument.*/
static Packet* generate (char packet_type[30])
	{
	Packet*				pkptr;
	double				pksize;
   
	FIN (generate ());

	
	/* Create a formatted packet */
	pkptr = op_pk_create_fmt (packet_type);
	
	
	FRET (pkptr);

	}

/* End of Function Block */

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void Power_monitor (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Obtype Power_monitor_init (int * init_block_ptr);
	VosT_Address Power_monitor_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype, int);
	void Power_monitor_diag (OP_SIM_CONTEXT_ARG_OPT);
	void Power_monitor_terminate (OP_SIM_CONTEXT_ARG_OPT);
	void Power_monitor_svar (void *, const char *, void **);


	VosT_Fun_Status Vos_Define_Object (VosT_Obtype * _op_obst_ptr, const char * _op_name, unsigned int _op_size, unsigned int _op_init_obs, unsigned int _op_inc_obs);
	VosT_Address Vos_Alloc_Object_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype _op_ob_hndl);
	VosT_Fun_Status Vos_Poolmem_Dealloc_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Address _op_ob_ptr);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
Power_monitor (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	FIN_MT (Power_monitor ());
	if (1)
		{
		/*These are variables used for storing the power received from the 
		packets and the highest power */
		
		double power;
		double highest_power;


		FSM_ENTER ("Power_monitor")

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (PACKETrec) enter executives **/
			FSM_STATE_ENTER_FORCED (0, "PACKETrec", state0_enter_exec, "Power_monitor [PACKETrec enter execs]")
				FSM_PROFILE_SECTION_IN ("Power_monitor [PACKETrec enter execs]", state0_enter_exec)
				{
				/* Data packets received from the Lower Layer are forwarded to the transmitter
				and the packets to monitor power are destroyed.*/
				
				Packet* packet_ptr;
				int streamNum;
				
				// Assign a pointer to the incoming packet
				packet_ptr = op_pk_get (op_intrpt_strm());
				
				//get the stream number of that the incoming packet arrived on
				streamNum = op_intrpt_strm();
				//printf("\npacket arrived at power_monitor on stream: %d\n",streamNum);
				
				if (streamNum == LOWERLAYER_TO_POWER_MONITOR)
					{
					/* forward packet to the transmitter */
					op_pk_send (packet_ptr, POWER_MONITOR_TO_TX);
					}
				else
					{
					/* destroy power packet */
					op_pk_destroy(packet_ptr);
					}
				}
				FSM_PROFILE_SECTION_OUT (state0_enter_exec)

			/** state (PACKETrec) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "PACKETrec", "Power_monitor [PACKETrec exit execs]")
				FSM_PROFILE_SECTION_IN ("Power_monitor [PACKETrec exit execs]", state0_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state0_exit_exec)


			/** state (PACKETrec) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "PACKETrec", "update")
				/*---------------------------------------------------------*/



			/** state (INIT) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (1, "INIT", "Power_monitor [INIT enter execs]")
				FSM_PROFILE_SECTION_IN ("Power_monitor [INIT enter execs]", state1_enter_exec)
				{
				/* Initialises the different variables used in the process.Finds the objectids 
				for the receiver channel and transmitter channel.Gets the value for IMSI from 
				the MS attribute*/
				
				int i;
				Objid ms_object_id;
				Objid tx_object_id;
				Objid rx_object_id;
				Objid tx_ch_comp_object_id;
				Objid rx_ch_comp_object_id;
				
				//time between channel power measurements in seconds
				measurement_interval = 5.0;
				next_measurement_time = 1.0e-03;
				best_channel = -1;
				
				printf("\nSimulation time: %e", op_sim_time());
				printf("\nNext measurement time: %e", next_measurement_time);
				printf("\nMeasurement interval: %e", measurement_interval);
				
				//Initialize the power table to null values
				for(i=0; i <= 5; i++)
				{
					power_table[i] = -1;
				}
				
				
				//get object ID of the Mobile Station Node Model
				ms_object_id = op_id_parent(op_id_self());
				printf("\nMS OBJ ID: %d", ms_object_id);
				
				//get the IMSI attribute
				op_ima_obj_attr_get (ms_object_id, "IMSI", &imsi);
				printf("\n(init Power Monitor)IMSI: %d", imsi);
				tlli = imsi;
				
				//get object ID of the Mobile Station Transmitter
				tx_object_id = op_id_from_name(ms_object_id, OPC_OBJTYPE_RATX, "transmitter");
				printf("\nTX OBJ ID: %d", tx_object_id);
				
				//get object ID of the Mobile Station Receiver
				rx_object_id = op_id_from_name(ms_object_id, OPC_OBJTYPE_RARX, "receiver");
				printf("\nRX OBJ ID: %d", rx_object_id);
				
				//get object ID of the Transmitter Channel Compound Attribute Object
				tx_ch_comp_object_id = op_topo_child(tx_object_id, OPC_OBJTYPE_COMP, 0);
				printf("\nTX COMP CH ATTR OBJ ID: %d", tx_ch_comp_object_id);
				
				//get object ID of the Receiver Channel Compound Attribute Object
				rx_ch_comp_object_id = op_topo_child(rx_object_id, OPC_OBJTYPE_COMP, 0);
				printf("\nRX COMP CH ATTR OBJ ID: %d", rx_ch_comp_object_id);
				
				//get object ID of the Transmitter Channel
				tx_ch_object_id = op_topo_child(tx_ch_comp_object_id, OPC_OBJTYPE_RATXCH, 0);
				printf("\nTX CH OBJ ID: %d", tx_ch_object_id);
				
				//get object ID of the Receiver Channel 6 (channels 0 to 5 are used for BCCHs)
				rx_ch_object_id = op_topo_child(rx_ch_comp_object_id, OPC_OBJTYPE_RARXCH, 6);
				printf("\nTX CH OBJ ID: %d", rx_ch_object_id);
				}
				FSM_PROFILE_SECTION_OUT (state1_enter_exec)

			/** state (INIT) exit executives **/
			FSM_STATE_EXIT_FORCED (1, "INIT", "Power_monitor [INIT exit execs]")
				FSM_PROFILE_SECTION_IN ("Power_monitor [INIT exit execs]", state1_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state1_exit_exec)


			/** state (INIT) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "INIT", "update")
				/*---------------------------------------------------------*/



			/** state (update) enter executives **/
			FSM_STATE_ENTER_UNFORCED (2, "update", state2_enter_exec, "Power_monitor [update enter execs]")
				FSM_PROFILE_SECTION_IN ("Power_monitor [update enter execs]", state2_enter_exec)
				{
				/*In this process, the MS calculates the channel with the highest power,
				sets the transmitter and receiver frequencies for transmitting signal.On the event of
				a cell update, creates an empty LLC frame and sent it to the SGSN*/
				
				int j;
				int previous_best_channel;
				double tx_freq;
				double rx_freq;
				double sim_time;
				
				Packet* llc_packet_ptr;
				int result;
				int my_address;
				
				
				sim_time = op_sim_time();
				op_intrpt_schedule_self (next_measurement_time,0);
				
				if (sim_time == next_measurement_time)
					{
					next_measurement_time = sim_time + measurement_interval;
				//	printf("\nIdle:Simulation time: %e", op_sim_time());
					
					previous_best_channel = best_channel;
					highest_power = 0.0;
					
					for (j = 0; j <= 5; j++)
						{
						if (power_table[j] > highest_power)
					   		{
							highest_power = power_table[j];
							best_channel = j;
							}
						
					    }
					
				//	printf("\nchannel with the highest power: %d", best_channel);
				//	printf("\nprevious channel with the highest power: %d", previous_best_channel);
				//	printf("\n(idle)Next measurement time: %e", next_measurement_time);
					
					tx_freq = 1850.2 + 10 * best_channel + 0.6 * (imsi + 1);
					rx_freq = tx_freq + 80;
					
					if (best_channel != previous_best_channel && best_channel != -1 && 
						OPC_COMPCODE_SUCCESS == op_ima_obj_attr_set (tx_ch_object_id, "min frequency", tx_freq))
					    {
						printf("\nnew transmitter frequency of MS nr. %d: %e", tlli, tx_freq);
						
						if(previous_best_channel != -1)
						 {
						 	//create empty LLC frame and send it to the TX
						 	my_address=4;
							llc_packet_ptr=generate("gprs_LLC_FRAME");
						
							if (llc_packet_ptr==OPC_NIL) 
							  {
							  	printf("\nPower_Monitor: llc_pkptr=NIL");
							  }
							else
							  {
				
							   result = op_pk_nfd_set (llc_packet_ptr, "tlli", tlli);
							   result = op_pk_nfd_set (llc_packet_ptr, "address", my_address);
							   // LLC Packet size = header size (Frame is empty)
				
							   //Send packet (gprs_LLC_FRAME)to Lower Layer peer in SGSN only if the MS is attached
							   if (msStatus[tlli].status != MSStatus_Detached)
								   {
								   op_pk_send(llc_packet_ptr, POWER_MONITOR_TO_TX);
								   printf("\ncell update llc frame send-----------------------------------------------------");
								   }
							   else
								   {
								   op_pk_destroy(llc_packet_ptr);
								   printf("\nempty llc frame deleted in the ms lowerlayer process because it is not attached");
								   }
							   }
							}
						op_ima_obj_attr_set (rx_ch_object_id, "min frequency", rx_freq);
						printf("\nnew receiver frequency:    %e", rx_freq);
						}
					}
				}
				FSM_PROFILE_SECTION_OUT (state2_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (5,"Power_monitor")


			/** state (update) exit executives **/
			FSM_STATE_EXIT_UNFORCED (2, "update", "Power_monitor [update exit execs]")
				FSM_PROFILE_SECTION_IN ("Power_monitor [update exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state2_exit_exec)


			/** state (update) transition processing **/
			FSM_PROFILE_SECTION_IN ("Power_monitor [update trans conditions]", state2_trans_conds)
			FSM_INIT_COND (PACKET_RECEIVED)
			FSM_TEST_COND (POWER_STAT_RECEIVED)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("update")
			FSM_PROFILE_SECTION_OUT (state2_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 0, state0_enter_exec, ;, "PACKET_RECEIVED", "", "update", "PACKETrec")
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;, "POWER_STAT_RECEIVED", "", "update", "POWER")
				FSM_CASE_TRANSIT (2, 2, state2_enter_exec, ;, "default", "", "update", "update")
				}
				/*---------------------------------------------------------*/



			/** state (POWER) enter executives **/
			FSM_STATE_ENTER_FORCED (3, "POWER", state3_enter_exec, "Power_monitor [POWER enter execs]")
				FSM_PROFILE_SECTION_IN ("Power_monitor [POWER enter execs]", state3_enter_exec)
				{
				/*In this state, the power fromm the incoming packets is read when a 
				statistical interrupt happens.The power is then stored in the power_table */
				int statnumber;
				statnumber = op_intrpt_stat();
				
				power = op_stat_local_read(statnumber);
				
				if (power !=0)
					{
						power_table[statnumber]=power;
					}
				
				//printf("\nReceived Power: %e", power);
				//printf("\nReceived Power[%d]: %e",statnumber, power_table[statnumber]);
				//printf("\n(power) Simulation Time: %e", op_sim_time());
				}
				FSM_PROFILE_SECTION_OUT (state3_enter_exec)

			/** state (POWER) exit executives **/
			FSM_STATE_EXIT_FORCED (3, "POWER", "Power_monitor [POWER exit execs]")
				FSM_PROFILE_SECTION_IN ("Power_monitor [POWER exit execs]", state3_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state3_exit_exec)


			/** state (POWER) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "POWER", "update")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (1,"Power_monitor")
		}
	}




void
Power_monitor_diag (OP_SIM_CONTEXT_ARG_OPT)
	{
	/* No Diagnostic Block */
	}




void
Power_monitor_terminate (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = __LINE__;
#endif

	FIN_MT (Power_monitor_terminate ())

	Vos_Poolmem_Dealloc_MT (OP_SIM_CONTEXT_THREAD_INDEX_COMMA pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in Power_monitor_svar function. */
#undef bits_rcvd_stathandle
#undef bitssec_rcvd_stathandle
#undef pkts_rcvd_stathandle
#undef pktssec_rcvd_stathandle
#undef ete_delay_stathandle
#undef bits_rcvd_gstathandle
#undef bitssec_rcvd_gstathandle
#undef pkts_rcvd_gstathandle
#undef pktssec_rcvd_gstathandle
#undef ete_delay_gstathandle
#undef power_table
#undef next_measurement_time
#undef measurement_interval
#undef best_channel
#undef tx_ch_object_id
#undef rx_ch_object_id
#undef imsi
#undef tlli

#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE

#define FIN_PREAMBLE_DEC
#define FIN_PREAMBLE_CODE

VosT_Obtype
Power_monitor_init (int * init_block_ptr)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	VosT_Obtype obtype = OPC_NIL;
	FIN_MT (Power_monitor_init (init_block_ptr))

	Vos_Define_Object (&obtype, "proc state vars (Power_monitor)",
		sizeof (Power_monitor_state), 0, 20);
	*init_block_ptr = 2;

	FRET (obtype)
	}

VosT_Address
Power_monitor_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype obtype, int init_block)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	Power_monitor_state * ptr;
	FIN_MT (Power_monitor_alloc (obtype))

	ptr = (Power_monitor_state *)Vos_Alloc_Object_MT (VOS_THREAD_INDEX_COMMA obtype);
	if (ptr != OPC_NIL)
		ptr->_op_current_block = init_block;
	FRET ((VosT_Address)ptr)
	}



void
Power_monitor_svar (void * gen_ptr, const char * var_name, void ** var_p_ptr)
	{
	Power_monitor_state		*prs_ptr;

	FIN_MT (Power_monitor_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (void *)OPC_NIL;
		FOUT
		}
	prs_ptr = (Power_monitor_state *)gen_ptr;

	if (strcmp ("bits_rcvd_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->bits_rcvd_stathandle);
		FOUT
		}
	if (strcmp ("bitssec_rcvd_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->bitssec_rcvd_stathandle);
		FOUT
		}
	if (strcmp ("pkts_rcvd_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->pkts_rcvd_stathandle);
		FOUT
		}
	if (strcmp ("pktssec_rcvd_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->pktssec_rcvd_stathandle);
		FOUT
		}
	if (strcmp ("ete_delay_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->ete_delay_stathandle);
		FOUT
		}
	if (strcmp ("bits_rcvd_gstathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->bits_rcvd_gstathandle);
		FOUT
		}
	if (strcmp ("bitssec_rcvd_gstathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->bitssec_rcvd_gstathandle);
		FOUT
		}
	if (strcmp ("pkts_rcvd_gstathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->pkts_rcvd_gstathandle);
		FOUT
		}
	if (strcmp ("pktssec_rcvd_gstathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->pktssec_rcvd_gstathandle);
		FOUT
		}
	if (strcmp ("ete_delay_gstathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->ete_delay_gstathandle);
		FOUT
		}
	if (strcmp ("power_table" , var_name) == 0)
		{
		*var_p_ptr = (void *) (prs_ptr->power_table);
		FOUT
		}
	if (strcmp ("next_measurement_time" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->next_measurement_time);
		FOUT
		}
	if (strcmp ("measurement_interval" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->measurement_interval);
		FOUT
		}
	if (strcmp ("best_channel" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->best_channel);
		FOUT
		}
	if (strcmp ("tx_ch_object_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->tx_ch_object_id);
		FOUT
		}
	if (strcmp ("rx_ch_object_id" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->rx_ch_object_id);
		FOUT
		}
	if (strcmp ("imsi" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->imsi);
		FOUT
		}
	if (strcmp ("tlli" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->tlli);
		FOUT
		}
	*var_p_ptr = (void *)OPC_NIL;

	FOUT
	}

