/* Process model C form file: bsc_router_process.pr.c */
/* Portions of this file copyright 1992-2003 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
const char bsc_router_process_pr_c [] = "MIL_3_Tfile_Hdr_ 100A 30A op_runsim 7 40E36431 40E36431 1 hermes rsn 0 0 none none 0 0 none 0 0 0 0 0 0 0 0 90b 2                                                                                                                                                                                                                                                                                                                                                                                                              ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>



/* Header Block */

// incoming stream macros
#define SGSN_TO_bsc_router		6
	
// outgoing stream macros
#define bsc_router_TO_BTS_0		0
#define bsc_router_TO_BTS_1		1
#define bsc_router_TO_BTS_2		2
#define bsc_router_TO_BTS_3		3
#define bsc_router_TO_BTS_4		4
#define bsc_router_TO_BTS_5		5
#define bsc_router_TO_SGSN		6


// transition macros

#define PACKET_FROM_SGSN	(op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () == SGSN_TO_bsc_router)
#define PACKET_FROM_BTS		(op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () != SGSN_TO_bsc_router)


/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(_op_last_line_passed) = __LINE__ - _op_block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(_op_last_line_passed) = 0; _op_block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	int	                    		routingTable[6];
	} bsc_router_process_state;

#define pr_state_ptr            		((bsc_router_process_state*) (OP_SIM_CONTEXT_PTR->mod_state_ptr))
#define routingTable            		pr_state_ptr->routingTable

/* These macro definitions will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE
#if defined (OPD_PARALLEL)
#  define FIN_PREAMBLE_DEC	bsc_router_process_state *op_sv_ptr; OpT_Sim_Context * tcontext_ptr;
#  define FIN_PREAMBLE_CODE	\
		if (VosS_Mt_Perform_Lock) \
			VOS_THREAD_SPECIFIC_DATA_GET (VosI_Globals.simi_mt_context_data_key, tcontext_ptr, SimT_Context *); \
		else \
			tcontext_ptr = VosI_Globals.simi_sequential_context_ptr; \
		op_sv_ptr = ((bsc_router_process_state *)(tcontext_ptr->mod_state_ptr));
#else
#  define FIN_PREAMBLE_DEC	bsc_router_process_state *op_sv_ptr;
#  define FIN_PREAMBLE_CODE	op_sv_ptr = pr_state_ptr;
#endif


/* No Function Block */


#if !defined (VOSD_NO_FIN)
enum { _op_block_origin = __LINE__ };
#endif

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void bsc_router_process (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Obtype bsc_router_process_init (int * init_block_ptr);
	VosT_Address bsc_router_process_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype, int);
	void bsc_router_process_diag (OP_SIM_CONTEXT_ARG_OPT);
	void bsc_router_process_terminate (OP_SIM_CONTEXT_ARG_OPT);
	void bsc_router_process_svar (void *, const char *, void **);


	VosT_Fun_Status Vos_Define_Object (VosT_Obtype * _op_obst_ptr, const char * _op_name, unsigned int _op_size, unsigned int _op_init_obs, unsigned int _op_inc_obs);
	VosT_Address Vos_Alloc_Object_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype _op_ob_hndl);
	VosT_Fun_Status Vos_Poolmem_Dealloc_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Address _op_ob_ptr);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
bsc_router_process (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	FIN_MT (bsc_router_process ());
	if (1)
		{


		FSM_ENTER ("bsc_router_process")

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (0, "idle", state0_enter_exec, "bsc_router_process [idle enter execs]")
				FSM_PROFILE_SECTION_IN ("bsc_router_process [idle enter execs]", state0_enter_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state0_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (1,"bsc_router_process")


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (0, "idle", "bsc_router_process [idle exit execs]")
				FSM_PROFILE_SECTION_IN ("bsc_router_process [idle exit execs]", state0_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state0_exit_exec)


			/** state (idle) transition processing **/
			FSM_PROFILE_SECTION_IN ("bsc_router_process [idle trans conditions]", state0_trans_conds)
			FSM_INIT_COND (PACKET_FROM_SGSN)
			FSM_TEST_COND (PACKET_FROM_BTS)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT (state0_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 1, state1_enter_exec, ;, "PACKET_FROM_SGSN", "", "idle", "download")
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;, "PACKET_FROM_BTS", "", "idle", "upload")
				FSM_CASE_TRANSIT (2, 0, state0_enter_exec, ;, "default", "", "idle", "idle")
				}
				/*---------------------------------------------------------*/



			/** state (download) enter executives **/
			FSM_STATE_ENTER_FORCED (1, "download", state1_enter_exec, "bsc_router_process [download enter execs]")
				FSM_PROFILE_SECTION_IN ("bsc_router_process [download enter execs]", state1_enter_exec)
				{
				// download: SGSN to BSC
				
				Packet* in_packet_ptr;
				//char* pk_format;
				int dummy;
				int streamNum;
				int tempTLLI;
				int i;
				
				// Assign a pointer to the incoming packet
				in_packet_ptr = op_pk_get (SGSN_TO_bsc_router);
				
				
				// get the tlli value and copy it to streamNum
				dummy = op_pk_nfd_get(in_packet_ptr, "tlli", &tempTLLI);
				// get the stream number that corresponds to the TLLI value
				// printf("tempTLLI: %d\n",tempTLLI);
				
				streamNum = routingTable[tempTLLI];
						
					
				// printf("streamNum: %d\n",streamNum);
				
				/* Route the incoming packet to the mobile station corresponding to the given TLLI 
				value if the stream number is within 0 to 5 */
				if(streamNum >= 0 && streamNum <= 5)
					{
						op_pk_send(in_packet_ptr, streamNum);
					}
				else
				{
				/* then destroy (effectively drop) that packet because the bsc can't handle
				   any more that the set 0 to 5 connections */
				op_pk_destroy(in_packet_ptr);
				printf("bsc_router_process: WARNING: PACKET DROPPED BY bsc DUE TO UNRECOGNIZED CONNECTION");
				printf( "%d\n",streamNum);
				}
				}
				FSM_PROFILE_SECTION_OUT (state1_enter_exec)

			/** state (download) exit executives **/
			FSM_STATE_EXIT_FORCED (1, "download", "bsc_router_process [download exit execs]")
				FSM_PROFILE_SECTION_IN ("bsc_router_process [download exit execs]", state1_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state1_exit_exec)


			/** state (download) transition processing **/
			FSM_TRANSIT_FORCE (0, state0_enter_exec, ;, "default", "", "download", "idle")
				/*---------------------------------------------------------*/



			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (2, "init", "bsc_router_process [init enter execs]")
				FSM_PROFILE_SECTION_IN ("bsc_router_process [init enter execs]", state2_enter_exec)
				{
				int i;
				
				//Initialize the routing table to null values
				for(i=0; i <= 5; i++)
				{
					routingTable[i] = -1;
				}
				}
				FSM_PROFILE_SECTION_OUT (state2_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "init", "bsc_router_process [init exit execs]")
				FSM_PROFILE_SECTION_IN ("bsc_router_process [init exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state2_exit_exec)


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (0, state0_enter_exec, ;, "default", "", "init", "idle")
				/*---------------------------------------------------------*/



			/** state (upload) enter executives **/
			FSM_STATE_ENTER_FORCED (3, "upload", state3_enter_exec, "bsc_router_process [upload enter execs]")
				FSM_PROFILE_SECTION_IN ("bsc_router_process [upload enter execs]", state3_enter_exec)
				{
				// upload: BSC to SGSN
				//printf("\nupload: init");
				Packet* in_packet_ptr;
				//char* pk_format;
				int dummy;
				int msTLLI;
				int streamNum;
				
				// Assign a pointer to the incoming packet
				in_packet_ptr = op_pk_get (op_intrpt_strm());
				
				// get the tlli value and copy it to msTLLI
				dummy = op_pk_nfd_get(in_packet_ptr, "tlli", &msTLLI);
				//printf("\nMSADDRESS: %d",msTLLI);
				// get the stream number that the incoming packet arrived on
				streamNum = op_intrpt_strm();
				//printf("\nstreamNum: %d",streamNum);
				
				/* store the Stream Number value into the state variable array
				in the index corresponding to the TLLI/IMSI */
				routingTable[msTLLI] = streamNum;
				
				
				//printf("\nroutingTable[%d]: %d",msTLLI,routingTable[msTLLI]);
				
				// and just route the packet to the SGSN
				op_pk_send(in_packet_ptr, bsc_router_TO_SGSN);
				}
				FSM_PROFILE_SECTION_OUT (state3_enter_exec)

			/** state (upload) exit executives **/
			FSM_STATE_EXIT_FORCED (3, "upload", "bsc_router_process [upload exit execs]")
				FSM_PROFILE_SECTION_IN ("bsc_router_process [upload exit execs]", state3_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state3_exit_exec)


			/** state (upload) transition processing **/
			FSM_TRANSIT_FORCE (0, state0_enter_exec, ;, "default", "", "upload", "idle")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (2,"bsc_router_process")
		}
	}




void
bsc_router_process_diag (OP_SIM_CONTEXT_ARG_OPT)
	{
	/* No Diagnostic Block */
	}




void
bsc_router_process_terminate (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = __LINE__;
#endif

	FIN_MT (bsc_router_process_terminate ())

	Vos_Poolmem_Dealloc_MT (OP_SIM_CONTEXT_THREAD_INDEX_COMMA pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in bsc_router_process_svar function. */
#undef routingTable

#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE

#define FIN_PREAMBLE_DEC
#define FIN_PREAMBLE_CODE

VosT_Obtype
bsc_router_process_init (int * init_block_ptr)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	VosT_Obtype obtype = OPC_NIL;
	FIN_MT (bsc_router_process_init (init_block_ptr))

	Vos_Define_Object (&obtype, "proc state vars (bsc_router_process)",
		sizeof (bsc_router_process_state), 0, 20);
	*init_block_ptr = 4;

	FRET (obtype)
	}

VosT_Address
bsc_router_process_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype obtype, int init_block)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	bsc_router_process_state * ptr;
	FIN_MT (bsc_router_process_alloc (obtype))

	ptr = (bsc_router_process_state *)Vos_Alloc_Object_MT (VOS_THREAD_INDEX_COMMA obtype);
	if (ptr != OPC_NIL)
		ptr->_op_current_block = init_block;
	FRET ((VosT_Address)ptr)
	}



void
bsc_router_process_svar (void * gen_ptr, const char * var_name, void ** var_p_ptr)
	{
	bsc_router_process_state		*prs_ptr;

	FIN_MT (bsc_router_process_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (void *)OPC_NIL;
		FOUT
		}
	prs_ptr = (bsc_router_process_state *)gen_ptr;

	if (strcmp ("routingTable" , var_name) == 0)
		{
		*var_p_ptr = (void *) (prs_ptr->routingTable);
		FOUT
		}
	*var_p_ptr = (void *)OPC_NIL;

	FOUT
	}

