/* Process model C form file: bts_router_process.pr.c */
/* Portions of this file copyright 1992-2003 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
const char bts_router_process_pr_c [] = "MIL_3_Tfile_Hdr_ 100A 30A op_runsim 7 40E364BB 40E364BB 1 hermes rsn 0 0 none none 0 0 none 0 0 0 0 0 0 0 0 90b 2                                                                                                                                                                                                                                                                                                                                                                                                              ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>



/* Header Block */

// incoming stream macros
#define BSC_TO_bs_router		15
	
// outgoing stream macros
#define bs_router_TO_MS_0		0
#define bs_router_TO_MS_1		1
#define bs_router_TO_MS_2		2
#define bs_router_TO_MS_3		3
#define bs_router_TO_MS_4		4
#define bs_router_TO_MS_5		5
#define bs_router_TO_MS_6		6
#define bs_router_TO_MS_7		7
#define bs_router_TO_MS_8		8
#define bs_router_TO_MS_9	    9
#define bs_router_TO_MS_10		10
#define bs_router_TO_MS_11		11
#define bs_router_TO_MS_12		12
#define bs_router_TO_MS_13		13
#define bs_router_TO_MS_14		14
#define bs_router_TO_BSC		15

// transition macros

#define PACKET_FROM_BSC	(op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () == BSC_TO_bs_router)
#define PACKET_FROM_MS		(op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () != BSC_TO_bs_router)
//#define PACKET_FROM_MS		(op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () != BSC_TO_bs_router)

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(_op_last_line_passed) = __LINE__ - _op_block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(_op_last_line_passed) = 0; _op_block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	int	                    		routingTable[15];
	} bts_router_process_state;

#define pr_state_ptr            		((bts_router_process_state*) (OP_SIM_CONTEXT_PTR->mod_state_ptr))
#define routingTable            		pr_state_ptr->routingTable

/* These macro definitions will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE
#if defined (OPD_PARALLEL)
#  define FIN_PREAMBLE_DEC	bts_router_process_state *op_sv_ptr; OpT_Sim_Context * tcontext_ptr;
#  define FIN_PREAMBLE_CODE	\
		if (VosS_Mt_Perform_Lock) \
			VOS_THREAD_SPECIFIC_DATA_GET (VosI_Globals.simi_mt_context_data_key, tcontext_ptr, SimT_Context *); \
		else \
			tcontext_ptr = VosI_Globals.simi_sequential_context_ptr; \
		op_sv_ptr = ((bts_router_process_state *)(tcontext_ptr->mod_state_ptr));
#else
#  define FIN_PREAMBLE_DEC	bts_router_process_state *op_sv_ptr;
#  define FIN_PREAMBLE_CODE	op_sv_ptr = pr_state_ptr;
#endif


/* No Function Block */


#if !defined (VOSD_NO_FIN)
enum { _op_block_origin = __LINE__ };
#endif

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void bts_router_process (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Obtype bts_router_process_init (int * init_block_ptr);
	VosT_Address bts_router_process_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype, int);
	void bts_router_process_diag (OP_SIM_CONTEXT_ARG_OPT);
	void bts_router_process_terminate (OP_SIM_CONTEXT_ARG_OPT);
	void bts_router_process_svar (void *, const char *, void **);


	VosT_Fun_Status Vos_Define_Object (VosT_Obtype * _op_obst_ptr, const char * _op_name, unsigned int _op_size, unsigned int _op_init_obs, unsigned int _op_inc_obs);
	VosT_Address Vos_Alloc_Object_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype _op_ob_hndl);
	VosT_Fun_Status Vos_Poolmem_Dealloc_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Address _op_ob_ptr);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
bts_router_process (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	FIN_MT (bts_router_process ());
	if (1)
		{


		FSM_ENTER ("bts_router_process")

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (0, "idle", state0_enter_exec, "bts_router_process [idle enter execs]")
				FSM_PROFILE_SECTION_IN ("bts_router_process [idle enter execs]", state0_enter_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state0_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (1,"bts_router_process")


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (0, "idle", "bts_router_process [idle exit execs]")
				FSM_PROFILE_SECTION_IN ("bts_router_process [idle exit execs]", state0_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state0_exit_exec)


			/** state (idle) transition processing **/
			FSM_PROFILE_SECTION_IN ("bts_router_process [idle trans conditions]", state0_trans_conds)
			FSM_INIT_COND (PACKET_FROM_BSC)
			FSM_TEST_COND (PACKET_FROM_MS)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT (state0_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 1, state1_enter_exec, ;, "PACKET_FROM_BSC", "", "idle", "download")
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;, "PACKET_FROM_MS", "", "idle", "upload")
				FSM_CASE_TRANSIT (2, 0, state0_enter_exec, ;, "default", "", "idle", "idle")
				}
				/*---------------------------------------------------------*/



			/** state (download) enter executives **/
			FSM_STATE_ENTER_FORCED (1, "download", state1_enter_exec, "bts_router_process [download enter execs]")
				FSM_PROFILE_SECTION_IN ("bts_router_process [download enter execs]", state1_enter_exec)
				{
				// download: BSC to MS
				
				Packet* in_packet_ptr;
				//char* pk_format;
				int dummy;
				int streamNum;
				int tempTLLI;
				int i;
				
				// Assign a pointer to the incoming packet
				in_packet_ptr = op_pk_get (BSC_TO_bs_router);
				
				/*
				// Gets the name of the packet format and stores it to the string pk_format
				op_pk_format (in_packet_ptr, pk_format);
				//  If the packet format is attachAccept
				if (strcmp(pk_format,"attachAccept")==0)
					{
					   	printf("Packet format is: %s",pk_format);
						// then get the allocatedPTMSI value
						// and copy it to streamNum
						dummy = op_pk_nfd_get(in_packet_ptr, "allocatedPTMSI", &streamNum);
					}
				else // else assume that it's a packet format with a TLLI field
					{
				   		printf("Packet format is: %s",pk_format);
				*/
				
				// get the tlli value and copy it to streamNum
				dummy = op_pk_nfd_get(in_packet_ptr, "tlli", &tempTLLI);
				// get the stream number that corresponds to the TLLI value
				//printf("\ntempTLLI: %d",tempTLLI);
				for(i = 0; i <= 14; i++)
					{// then if the i'th value in the array is the TLLI value we are looking for
						if(routingTable[i] == tempTLLI)
						{// then the i value is the stream number corresponding to that array
							streamNum = i;
						}
					}
				//printf("\nstreamNum: %d",streamNum);
				
				/* Added by Paulman: Route the incoming packet to the mobile station
				   corresponding to the given TLLI value */
				// if the stream number is within 0 to 14
				if(streamNum >= 0 && streamNum <= 14)
					{// then send the packet to that stream
						op_pk_send(in_packet_ptr, streamNum);
						
				//	   printf("\nPacket send to MS with TLLI: %d",tempTLLI);
					}
				else
				{
				/* then destroy (effectively drop) that packet because the BS can't handle
				   any more that the set 0 to 14 connections */
				op_pk_destroy(in_packet_ptr);
				printf("bs_router_process: WARNING: PACKET DROPPED BY BS DUE TO UNRECOGNIZED CONNECTION");
				printf( "%d\n",streamNum);
				}
				}
				FSM_PROFILE_SECTION_OUT (state1_enter_exec)

			/** state (download) exit executives **/
			FSM_STATE_EXIT_FORCED (1, "download", "bts_router_process [download exit execs]")
				FSM_PROFILE_SECTION_IN ("bts_router_process [download exit execs]", state1_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state1_exit_exec)


			/** state (download) transition processing **/
			FSM_TRANSIT_FORCE (0, state0_enter_exec, ;, "default", "", "download", "idle")
				/*---------------------------------------------------------*/



			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (2, "init", "bts_router_process [init enter execs]")
				FSM_PROFILE_SECTION_IN ("bts_router_process [init enter execs]", state2_enter_exec)
				{
				/* Initialises the different variables used in the process.Finds the objectids 
				for the receiver channel and transmitter channeland sets the BCCH,transmitter and 
				receiver frequencies*/
				int i;
				Objid  bts_object_id;
				Objid tx_object_id;
				Objid rx_object_id;
				Objid tx_ch_comp_object_id;
				Objid rx_ch_comp_object_id;
				Objid tx_ch_object_id[16];
				Objid rx_ch_object_id[15];
				double bcch_frequency;
				double tx_freq;
				double rx_freq;
				
				//Initialize the routing table to null values
				for(i=0; i <= 14; i++)
				{
					routingTable[i] = -1;
				}
				
				//get object ID of the Base Station Node Model
				bts_object_id = op_id_parent(op_id_self());
				//printf("\nBTS OBJ ID: %d", bts_object_id);
				
				//get object ID of the Mobile Station Transmitter
				tx_object_id = op_id_from_name(bts_object_id, OPC_OBJTYPE_RATX, "rt_0");
				//printf("\nBTS TX OBJ ID: %d", tx_object_id);
				
				//get object ID of the Mobile Station Receiver
				rx_object_id = op_id_from_name(bts_object_id, OPC_OBJTYPE_RARX, "rr_0");
				//printf("\nBTS RX OBJ ID: %d", rx_object_id);
				
				//get object ID of the Transmitter Channel Compound Attribute Object
				tx_ch_comp_object_id = op_topo_child(tx_object_id, OPC_OBJTYPE_COMP, 0);
				//printf("\nBTS TX COMP CH ATTR OBJ ID: %d", tx_ch_comp_object_id);
				
				//get object ID of the Receiver Channel Compound Attribute Object
				rx_ch_comp_object_id = op_topo_child(rx_object_id, OPC_OBJTYPE_COMP, 0);
				//printf("\nBTS RX COMP CH ATTR OBJ ID: %d", rx_ch_comp_object_id);
				
				//get object IDs of the Transmitter Channels
				for (i=0; i <= 15; i++)
					{
					tx_ch_object_id[i] = op_topo_child(tx_ch_comp_object_id, OPC_OBJTYPE_RATXCH, i);
					//printf("\nBTS TX CH OBJ ID: %d", tx_ch_object_id[i]);
					}
				
				//get the BCCH frequency
				op_ima_obj_attr_get (tx_ch_object_id[0], "min frequency", &bcch_frequency);
				printf("\nBTS BCCH FREQUENCY: %e", bcch_frequency);
				
				//set frequencies of the Transmitter Channels
				for (i=1; i <= 15; i++)
					{
					tx_freq = bcch_frequency + 0.6 * i;
					op_ima_obj_attr_set (tx_ch_object_id[i], "min frequency", tx_freq);
					printf("\nBTS TX FREQUENCY: %e", tx_freq);
					}
				
				//get object IDs of the Receiver Channels
				for (i=0; i <= 14; i++)
					{
					rx_ch_object_id[i] = op_topo_child(rx_ch_comp_object_id, OPC_OBJTYPE_RARXCH, i);
					//printf("\nBTS RX CH OBJ ID: %d", rx_ch_object_id[i]);
					}
				
				//set frequencies of the Receiver Channels
				for (i=0; i <= 14; i++)
					{
					rx_freq = bcch_frequency - 80 + 0.6 * (i+1);
					op_ima_obj_attr_set (rx_ch_object_id[i], "min frequency", rx_freq);
					printf("\nBTS RX FREQUENCY: %e", rx_freq);
					}
				}
				FSM_PROFILE_SECTION_OUT (state2_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "init", "bts_router_process [init exit execs]")
				FSM_PROFILE_SECTION_IN ("bts_router_process [init exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state2_exit_exec)


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (0, state0_enter_exec, ;, "default", "", "init", "idle")
				/*---------------------------------------------------------*/



			/** state (upload) enter executives **/
			FSM_STATE_ENTER_FORCED (3, "upload", state3_enter_exec, "bts_router_process [upload enter execs]")
				FSM_PROFILE_SECTION_IN ("bts_router_process [upload enter execs]", state3_enter_exec)
				{
				// upload: MS to BSC
				//printf("\nupload: init");
				Packet* in_packet_ptr;
				//char* pk_format;
				int dummy;
				int msTLLI;
				int streamNum;
				
				// Assign a pointer to the incoming packet
				in_packet_ptr = op_pk_get (op_intrpt_strm());
				
				/*
				// Gets the name of the packet format and stores it to the string pk_format
				op_pk_format (in_packet_ptr, pk_format);
				//  If the packet format is attachAccept
				if (strcmp(pk_format,"attachAccept")==0)
					{
					   	printf("Packet format is: %s",pk_format);
						// then get the allocatedPTMSI value
						// and copy it to msAddress
						dummy = op_pk_nfd_get(in_packet_ptr, "allocatedPTMSI", &msAddress);
					}
				else // else assume that it's a packet format with a TLLI field
					{
				   		printf("Packet format is: %s",pk_format);
				*/
				
				// get the tlli value and copy it to msAddress
				dummy = op_pk_nfd_get(in_packet_ptr, "tlli", &msTLLI);
				//printf("\nPacket received from MS with TLLI: %d",msTLLI);
				// get the stream number that the incoming packet arrived on
				streamNum = op_intrpt_strm();
				//printf("\nstreamNum: %d",streamNum);
				/* store the IMSI/TLLI value into the state variable array
				in the index corresponding to the stream number */
				routingTable[streamNum] = msTLLI;
				//printf("\nroutingTable[%d]: %d",streamNum,routingTable[streamNum]);
				
				// and just route the packet to the BSC
				op_pk_send(in_packet_ptr, bs_router_TO_BSC);
				}
				FSM_PROFILE_SECTION_OUT (state3_enter_exec)

			/** state (upload) exit executives **/
			FSM_STATE_EXIT_FORCED (3, "upload", "bts_router_process [upload exit execs]")
				FSM_PROFILE_SECTION_IN ("bts_router_process [upload exit execs]", state3_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state3_exit_exec)


			/** state (upload) transition processing **/
			FSM_TRANSIT_FORCE (0, state0_enter_exec, ;, "default", "", "upload", "idle")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (2,"bts_router_process")
		}
	}




void
bts_router_process_diag (OP_SIM_CONTEXT_ARG_OPT)
	{
	/* No Diagnostic Block */
	}




void
bts_router_process_terminate (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = __LINE__;
#endif

	FIN_MT (bts_router_process_terminate ())

	Vos_Poolmem_Dealloc_MT (OP_SIM_CONTEXT_THREAD_INDEX_COMMA pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in bts_router_process_svar function. */
#undef routingTable

#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE

#define FIN_PREAMBLE_DEC
#define FIN_PREAMBLE_CODE

VosT_Obtype
bts_router_process_init (int * init_block_ptr)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	VosT_Obtype obtype = OPC_NIL;
	FIN_MT (bts_router_process_init (init_block_ptr))

	Vos_Define_Object (&obtype, "proc state vars (bts_router_process)",
		sizeof (bts_router_process_state), 0, 20);
	*init_block_ptr = 4;

	FRET (obtype)
	}

VosT_Address
bts_router_process_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype obtype, int init_block)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	bts_router_process_state * ptr;
	FIN_MT (bts_router_process_alloc (obtype))

	ptr = (bts_router_process_state *)Vos_Alloc_Object_MT (VOS_THREAD_INDEX_COMMA obtype);
	if (ptr != OPC_NIL)
		ptr->_op_current_block = init_block;
	FRET ((VosT_Address)ptr)
	}



void
bts_router_process_svar (void * gen_ptr, const char * var_name, void ** var_p_ptr)
	{
	bts_router_process_state		*prs_ptr;

	FIN_MT (bts_router_process_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (void *)OPC_NIL;
		FOUT
		}
	prs_ptr = (bts_router_process_state *)gen_ptr;

	if (strcmp ("routingTable" , var_name) == 0)
		{
		*var_p_ptr = (void *) (prs_ptr->routingTable);
		FOUT
		}
	*var_p_ptr = (void *)OPC_NIL;

	FOUT
	}

