/* Process model C form file: detachProcedure.pr.c */
/* Portions of this file copyright 1992-2000 by OPNET, Inc. */



/* This variable carries the header into the object file */
static const char detachProcedure_pr_c [] = "MIL_3_Tfile_Hdr_ 70B 30A opnet 7 3BE5B991 3BE5B991 1 pauli rickyn 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                           ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */


#define DETACH_RCV_IN_STRM 0

#define DETACH_SRC_IN_STRM 1

#define DETACH_XMT_OUT_STRM 0

#define DETACH_ACCEPT 0x06


/* transition macros */
#define DETACH_SRC_ARRIVAL (op_intrpt_type () == \
OPC_INTRPT_STRM && op_intrpt_strm () == DETACH_SRC_IN_STRM)

#define DETACH_RCV_ARRIVAL (op_intrpt_type () == \
OPC_INTRPT_STRM && op_intrpt_strm () == DETACH_RCV_IN_STRM)

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	Distribution *	         		imsi_distribution;
	Stathandle	             		detachProcessTime_gsh;
	char	                   		debugStr[1000];
	} detachProcedure_state;

#define pr_state_ptr            		((detachProcedure_state*) SimI_Mod_State_Ptr)
#define imsi_distribution       		pr_state_ptr->imsi_distribution
#define detachProcessTime_gsh   		pr_state_ptr->detachProcessTime_gsh
#define debugStr                		pr_state_ptr->debugStr

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	detachProcedure_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

#if defined (__cplusplus)
extern "C" {
#endif
	void detachProcedure (void);
	Compcode detachProcedure_init (void **);
	void detachProcedure_diag (void);
	void detachProcedure_terminate (void);
	void detachProcedure_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
detachProcedure (void)
	{
	int _block_origin = 0;
	FIN (detachProcedure ());
	if (1)
		{
		Packet *pkptr;
		
		double detachProcessTime;
		double sentTime;


		FSM_ENTER (detachProcedure)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED (0, state0_enter_exec, "init", "detachProcedure () [init enter execs]")
				{
				// currently supports only 1000 subscribers
				imsi_distribution = op_dist_load ("uniform_int", 0, 999);
				
				detachProcessTime_gsh = op_stat_reg ("Detach Process Time",
					OPC_STAT_INDEX_NONE, OPC_STAT_GLOBAL);
				sprintf (debugStr, "Initialize Detach Procedure");
				op_prg_odb_print_major ("Debug message for MS-SGSN", debugStr, OPC_NIL);
				}


			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, state0_exit_exec, "init", "detachProcedure () [init exit execs]")
				{
				}


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "idle", "detachProcedure () [idle enter execs]")
				{
				}


			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,detachProcedure)


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, state1_exit_exec, "idle", "detachProcedure () [idle exit execs]")
				{
				}


			/** state (idle) transition processing **/
			FSM_INIT_COND (DETACH_SRC_ARRIVAL)
			FSM_TEST_COND (DETACH_RCV_ARRIVAL)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("idle")

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;)
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;)
				FSM_CASE_TRANSIT (2, 1, state1_enter_exec, ;)
				}
				/*---------------------------------------------------------*/



			/** state (detachXmt) enter executives **/
			FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "detachXmt", "detachProcedure () [detachXmt enter execs]")
				{
				pkptr = op_pk_get(DETACH_SRC_IN_STRM);
				sentTime = op_sim_time();
				// set the detach request sent time
				op_pk_nfd_set (pkptr, "detachReqSentTime",
					sentTime);
				sprintf (debugStr, "Detach Req sent.  Detach Req sent time %f", sentTime);
				op_prg_odb_print_major ("Debug message for MS-SGSN", debugStr, OPC_NIL);
				
				// set the imsi of the MS
				op_pk_nfd_set (pkptr, "ptmsi",
					(int)op_dist_outcome(imsi_distribution));
				op_pk_send(pkptr, DETACH_XMT_OUT_STRM);
				}


			/** state (detachXmt) exit executives **/
			FSM_STATE_EXIT_FORCED (2, state2_exit_exec, "detachXmt", "detachProcedure () [detachXmt exit execs]")
				{
				}


			/** state (detachXmt) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			/** state (detachRcv) enter executives **/
			FSM_STATE_ENTER_FORCED (3, state3_enter_exec, "detachRcv", "detachProcedure () [detachRcv enter execs]")
				{
				double detachReqSentTime;
				
				pkptr = op_pk_get(DETACH_RCV_IN_STRM);
				op_pk_nfd_get (pkptr, "detachReqSentTime", &detachReqSentTime);
				detachProcessTime = op_sim_time() - detachReqSentTime;
				op_stat_write(detachProcessTime_gsh, detachProcessTime);
				
				sprintf (debugStr, "Detach Accept Recv. Detach Req sent time %f", detachReqSentTime);
				//op_prg_odb_print_major ("Debug message for MS-SGSN", debugStr, OPC_NIL);
				
				sprintf (debugStr, "Detach Accept Recv. Detach Accept Recv time %f", op_sim_time());
				//op_prg_odb_print_major ("Debug message for MS-SGSN", debugStr, OPC_NIL);
				
				op_pk_destroy(pkptr);
				}


			/** state (detachRcv) exit executives **/
			FSM_STATE_EXIT_FORCED (3, state3_exit_exec, "detachRcv", "detachProcedure () [detachRcv exit execs]")
				{
				}


			/** state (detachRcv) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,detachProcedure)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
detachProcedure_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (detachProcedure_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (detachProcedure)",
			sizeof (detachProcedure_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((detachProcedure_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
detachProcedure_diag (void)
	{
	/* No Diagnostic Block */
	}




void
detachProcedure_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (detachProcedure_terminate (void))

	if (1)
		{
		Packet *pkptr;
		
		double detachProcessTime;
		double sentTime;

		/* No Termination Block */

		}
	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT;
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in detachProcedure_svar function. */
#undef imsi_distribution
#undef detachProcessTime_gsh
#undef debugStr



void
detachProcedure_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	detachProcedure_state		*prs_ptr;

	FIN (detachProcedure_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT;
		}
	prs_ptr = (detachProcedure_state *)gen_ptr;

	if (strcmp ("imsi_distribution" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->imsi_distribution);
		FOUT;
		}
	if (strcmp ("detachProcessTime_gsh" , var_name) == 0)
		{
		*var_p_ptr = (char *) (&prs_ptr->detachProcessTime_gsh);
		FOUT;
		}
	if (strcmp ("debugStr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (prs_ptr->debugStr);
		FOUT;
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT;
	}

