/* Process model C form file: gprs_lower_layer_process.pr.c */
/* Portions of this file copyright 1992-2003 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
const char gprs_lower_layer_process_pr_c [] = "MIL_3_Tfile_Hdr_ 100A 30A op_runsim 7 40E364C0 40E364C0 1 hermes rsn 0 0 none none 0 0 none 0 0 0 0 0 0 0 0 90b 2                                                                                                                                                                                                                                                                                                                                                                                                              ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>



/* Header Block */

//Current layer is named LOWERLAYER and represents RLC/MAC 
//on the MS side and BSSGP on the SGSN side. It also 
//represents the physical layers in the GPRS stack

#include "gprs_llc.h"
#include "msRecord.h"

/* incoming stream macros */
#define LLC_TO_LOWERLAYER			0
#define RX_TO_LOWERLAYER			1


/* outgoing stream macros */
#define LOWERLAYER_TO_LLC			0 
#define LOWERLAYER_TO_POWER_MONITOR	1

/* transition macros */
#define PACKET_FROM_RX (op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () == RX_TO_LOWERLAYER)
#define PACKET_FROM_LLC (op_intrpt_type () == OPC_INTRPT_STRM && op_intrpt_strm () == LLC_TO_LOWERLAYER)

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(_op_last_line_passed) = __LINE__ - _op_block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(_op_last_line_passed) = 0; _op_block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	} gprs_lower_layer_process_state;

#define pr_state_ptr            		((gprs_lower_layer_process_state*) (OP_SIM_CONTEXT_PTR->mod_state_ptr))

/* These macro definitions will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE
#if defined (OPD_PARALLEL)
#  define FIN_PREAMBLE_DEC	gprs_lower_layer_process_state *op_sv_ptr; OpT_Sim_Context * tcontext_ptr;
#  define FIN_PREAMBLE_CODE	\
		if (VosS_Mt_Perform_Lock) \
			VOS_THREAD_SPECIFIC_DATA_GET (VosI_Globals.simi_mt_context_data_key, tcontext_ptr, SimT_Context *); \
		else \
			tcontext_ptr = VosI_Globals.simi_sequential_context_ptr; \
		op_sv_ptr = ((gprs_lower_layer_process_state *)(tcontext_ptr->mod_state_ptr));
#else
#  define FIN_PREAMBLE_DEC	gprs_lower_layer_process_state *op_sv_ptr;
#  define FIN_PREAMBLE_CODE	op_sv_ptr = pr_state_ptr;
#endif


/* No Function Block */


#if !defined (VOSD_NO_FIN)
enum { _op_block_origin = __LINE__ };
#endif

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void gprs_lower_layer_process (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Obtype gprs_lower_layer_process_init (int * init_block_ptr);
	VosT_Address gprs_lower_layer_process_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype, int);
	void gprs_lower_layer_process_diag (OP_SIM_CONTEXT_ARG_OPT);
	void gprs_lower_layer_process_terminate (OP_SIM_CONTEXT_ARG_OPT);
	void gprs_lower_layer_process_svar (void *, const char *, void **);


	VosT_Fun_Status Vos_Define_Object (VosT_Obtype * _op_obst_ptr, const char * _op_name, unsigned int _op_size, unsigned int _op_init_obs, unsigned int _op_inc_obs);
	VosT_Address Vos_Alloc_Object_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype _op_ob_hndl);
	VosT_Fun_Status Vos_Poolmem_Dealloc_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Address _op_ob_ptr);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
gprs_lower_layer_process (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	FIN_MT (gprs_lower_layer_process ());
	if (1)
		{


		FSM_ENTER ("gprs_lower_layer_process")

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "init", "gprs_lower_layer_process [init enter execs]")
				FSM_PROFILE_SECTION_IN ("gprs_lower_layer_process [init enter execs]", state0_enter_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state0_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "init", "gprs_lower_layer_process [init exit execs]")
				FSM_PROFILE_SECTION_IN ("gprs_lower_layer_process [init exit execs]", state0_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state0_exit_exec)


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "init", "idle")
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, "idle", state1_enter_exec, "gprs_lower_layer_process [idle enter execs]")
				FSM_PROFILE_SECTION_IN ("gprs_lower_layer_process [idle enter execs]", state1_enter_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,"gprs_lower_layer_process")


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "idle", "gprs_lower_layer_process [idle exit execs]")
				FSM_PROFILE_SECTION_IN ("gprs_lower_layer_process [idle exit execs]", state1_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state1_exit_exec)


			/** state (idle) transition processing **/
			FSM_PROFILE_SECTION_IN ("gprs_lower_layer_process [idle trans conditions]", state1_trans_conds)
			FSM_INIT_COND (PACKET_FROM_LLC)
			FSM_TEST_COND (PACKET_FROM_RX)
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT (state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;, "PACKET_FROM_LLC", "", "idle", "send")
				FSM_CASE_TRANSIT (1, 3, state3_enter_exec, ;, "PACKET_FROM_RX", "", "idle", "rec")
				}
				/*---------------------------------------------------------*/



			/** state (send) enter executives **/
			FSM_STATE_ENTER_FORCED (2, "send", state2_enter_exec, "gprs_lower_layer_process [send enter execs]")
				FSM_PROFILE_SECTION_IN ("gprs_lower_layer_process [send enter execs]", state2_enter_exec)
				{
				//extract the LLC frame from the incoming packets and send to the power monitor.
				//destroy the incoming packet pointer.
				Packet* in_packet_ptr;
				Packet* out_packet_ptr;
				Packet* ll_pdu_ptr;
				int my_value; 
				int result;	
					
				/* Get a pointer to received packet*/
				in_packet_ptr = op_pk_get (LLC_TO_LOWERLAYER);
				
				
				//Extract LLC-frame from gprs_GRR_UNITDTA_REQ 
				result = op_pk_nfd_get(in_packet_ptr, "ll_pdu", &ll_pdu_ptr);
				
				//Send packet (gprs_LLC_FRAME)to Lower Layer peer in SGSN
				out_packet_ptr = ll_pdu_ptr;
				
				op_pk_send(out_packet_ptr, LOWERLAYER_TO_POWER_MONITOR);
				
				/*destroy the incoming packet*/	
				op_pk_destroy (in_packet_ptr);
				
				}
				FSM_PROFILE_SECTION_OUT (state2_enter_exec)

			/** state (send) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "send", "gprs_lower_layer_process [send exit execs]")
				FSM_PROFILE_SECTION_IN ("gprs_lower_layer_process [send exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state2_exit_exec)


			/** state (send) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "send", "idle")
				/*---------------------------------------------------------*/



			/** state (rec) enter executives **/
			FSM_STATE_ENTER_FORCED (3, "rec", state3_enter_exec, "gprs_lower_layer_process [rec enter execs]")
				FSM_PROFILE_SECTION_IN ("gprs_lower_layer_process [rec enter execs]", state3_enter_exec)
				{
				Packet* in_packet_ptr;
				Packet* out_packet_ptr;
				int my_value; 
				int result, tlli;	
				double llc_frame_size, gprs_GRR_UNITDATA_IND_header_size;
				double gprs_GRR_UNITDATA_IND_size;
					
				/* Get a pointer to received packet, which is and gprs_LLC_FRAME*/
				in_packet_ptr = op_pk_get (RX_TO_LOWERLAYER);
				
				llc_frame_size= (double) op_pk_total_size_get(in_packet_ptr);
				
				result=op_pk_nfd_get(in_packet_ptr, "tlli", &tlli);
				
				//printf("\nPacket with TLLI received by MS: %d", tlli);
				
				//Create gprs_GRR_UNITDATA_IND, put LLC-frame inside and send up
				//to LLC for demultiplexing 
				
				out_packet_ptr = op_pk_create_fmt ("gprs_GRR_UNITDATA_IND");
				result=op_pk_nfd_set(out_packet_ptr, "ll_pdu", in_packet_ptr);
				result=op_pk_nfd_set(out_packet_ptr, "tlli", tlli);
				result=op_pk_nfd_set(out_packet_ptr, "message_type", gprs_GRR_UNITDATA_IND);
				
				gprs_GRR_UNITDATA_IND_header_size= (double) op_pk_total_size_get (out_packet_ptr);
				gprs_GRR_UNITDATA_IND_size=gprs_GRR_UNITDATA_IND_header_size+llc_frame_size;
				
				//Set size we want packet to show network
				op_pk_total_size_set(out_packet_ptr, gprs_GRR_UNITDATA_IND_size);
				
				op_pk_send(out_packet_ptr, LOWERLAYER_TO_LLC);
				
				}
				FSM_PROFILE_SECTION_OUT (state3_enter_exec)

			/** state (rec) exit executives **/
			FSM_STATE_EXIT_FORCED (3, "rec", "gprs_lower_layer_process [rec exit execs]")
				FSM_PROFILE_SECTION_IN ("gprs_lower_layer_process [rec exit execs]", state3_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state3_exit_exec)


			/** state (rec) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "rec", "idle")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,"gprs_lower_layer_process")
		}
	}




void
gprs_lower_layer_process_diag (OP_SIM_CONTEXT_ARG_OPT)
	{
	/* No Diagnostic Block */
	}




void
gprs_lower_layer_process_terminate (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = __LINE__;
#endif

	FIN_MT (gprs_lower_layer_process_terminate ())

	Vos_Poolmem_Dealloc_MT (OP_SIM_CONTEXT_THREAD_INDEX_COMMA pr_state_ptr);

	FOUT
	}


#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE

#define FIN_PREAMBLE_DEC
#define FIN_PREAMBLE_CODE

VosT_Obtype
gprs_lower_layer_process_init (int * init_block_ptr)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	VosT_Obtype obtype = OPC_NIL;
	FIN_MT (gprs_lower_layer_process_init (init_block_ptr))

	Vos_Define_Object (&obtype, "proc state vars (gprs_lower_layer_process)",
		sizeof (gprs_lower_layer_process_state), 0, 20);
	*init_block_ptr = 0;

	FRET (obtype)
	}

VosT_Address
gprs_lower_layer_process_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype obtype, int init_block)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	gprs_lower_layer_process_state * ptr;
	FIN_MT (gprs_lower_layer_process_alloc (obtype))

	ptr = (gprs_lower_layer_process_state *)Vos_Alloc_Object_MT (VOS_THREAD_INDEX_COMMA obtype);
	if (ptr != OPC_NIL)
		ptr->_op_current_block = init_block;
	FRET ((VosT_Address)ptr)
	}



void
gprs_lower_layer_process_svar (void * gen_ptr, const char * var_name, void ** var_p_ptr)
	{

	FIN_MT (gprs_lower_layer_process_svar (gen_ptr, var_name, var_p_ptr))

	*var_p_ptr = (void *)OPC_NIL;

	FOUT
	}

