/* Process model C form file: hlr_process_model.pr.c */
/* Portions of this file copyright 1992-2003 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
const char hlr_process_model_pr_c [] = "MIL_3_Tfile_Hdr_ 100A 30A op_runsim 7 40E364B7 40E364B7 1 hermes rsn 0 0 none none 0 0 none 0 0 0 0 0 0 0 0 90b 2                                                                                                                                                                                                                                                                                                                                                                                                              ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>



/* Header Block */

#include "msRecord.h"
#include "map.h"

#define HLR_MAP_DSM_IN_STRM 0
#define HLR_MAP_RSM_IN_STRM 1
#define HLR_MAP_PSM_IN_STRM 2
#define HLR_OUT_STRM 0

#define NUM_OF_MS_RECORDS 100


/* transition macros */

#define MSG_FROM_MAP (op_intrpt_type () == OPC_INTRPT_STRM && \
(op_intrpt_strm () == HLR_MAP_DSM_IN_STRM || op_intrpt_strm () == HLR_MAP_RSM_IN_STRM || \
op_intrpt_strm () == HLR_MAP_PSM_IN_STRM))

#define OPENING (MSG_FROM_MAP && \
(messageType == MAP_OPEN_IND || \
(messageType == MAP_OPEN_CNF && appContext == context && result == DIALOGUE_ACCEPTED)))

#define UPDATE_LOCATION_IND_RCVD (MSG_FROM_MAP && \
messageType == MAP_UPDATE_GPRS_LOCATION_IND && context == gprsLocationUpdateContext)

#define FINISHED finished

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(_op_last_line_passed) = __LINE__ - _op_block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(_op_last_line_passed) = 0; _op_block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	char	                   		debugStr[1000];
	MSRecord	               		msRecordArray[100];
	int	                    		context;
	} hlr_process_model_state;

#define pr_state_ptr            		((hlr_process_model_state*) (OP_SIM_CONTEXT_PTR->mod_state_ptr))
#define debugStr                		pr_state_ptr->debugStr
#define msRecordArray           		pr_state_ptr->msRecordArray
#define context                 		pr_state_ptr->context

/* These macro definitions will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE
#if defined (OPD_PARALLEL)
#  define FIN_PREAMBLE_DEC	hlr_process_model_state *op_sv_ptr; OpT_Sim_Context * tcontext_ptr;
#  define FIN_PREAMBLE_CODE	\
		if (VosS_Mt_Perform_Lock) \
			VOS_THREAD_SPECIFIC_DATA_GET (VosI_Globals.simi_mt_context_data_key, tcontext_ptr, SimT_Context *); \
		else \
			tcontext_ptr = VosI_Globals.simi_sequential_context_ptr; \
		op_sv_ptr = ((hlr_process_model_state *)(tcontext_ptr->mod_state_ptr));
#else
#  define FIN_PREAMBLE_DEC	hlr_process_model_state *op_sv_ptr;
#  define FIN_PREAMBLE_CODE	op_sv_ptr = pr_state_ptr;
#endif


/* No Function Block */


#if !defined (VOSD_NO_FIN)
enum { _op_block_origin = __LINE__ };
#endif

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void hlr_process_model (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Obtype hlr_process_model_init (int * init_block_ptr);
	VosT_Address hlr_process_model_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype, int);
	void hlr_process_model_diag (OP_SIM_CONTEXT_ARG_OPT);
	void hlr_process_model_terminate (OP_SIM_CONTEXT_ARG_OPT);
	void hlr_process_model_svar (void *, const char *, void **);


	VosT_Fun_Status Vos_Define_Object (VosT_Obtype * _op_obst_ptr, const char * _op_name, unsigned int _op_size, unsigned int _op_init_obs, unsigned int _op_inc_obs);
	VosT_Address Vos_Alloc_Object_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype _op_ob_hndl);
	VosT_Fun_Status Vos_Poolmem_Dealloc_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Address _op_ob_ptr);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
hlr_process_model (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	FIN_MT (hlr_process_model ());
	if (1)
		{
		Packet * pkptr;
		Packet* map_open_res_pkptr;
		Packet* map_insert_sbsr_data_req_pkptr;
		Packet* map_update_gprs_loc_res_pkptr;
		Packet* map_close_req_pkptr;
		int messageType;
		int intrpt_type;
		int appContext;
		int result;
		int finished;
		int imsi;


		FSM_ENTER ("hlr_process_model")

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (INIT) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "INIT", "hlr_process_model [INIT enter execs]")
				FSM_PROFILE_SECTION_IN ("hlr_process_model [INIT enter execs]", state0_enter_exec)
				{
				List* HLRListPtr;
				List* subscribedInfoListPtr;
				int numRows, i;
				int imsi;
				char* apn;
				int qosReliablityClass, qosDelayClass, qosPrecedenceClass;
				int qosPeakBitRate, qosMeanBitRate, pdpType;
				char* pdpAddress; 
				QoS qosSubscribedStruct;
				PDPAddress pdpAddressStruct;
				APN apnStruct;
				
				// initialize the state variables: msRecords
				for (i=0; i < NUM_OF_MS_RECORDS; i++)
					{
					  msRecordArray[i].isSet = 0;
					}
				
				
				// open and read the HLR.gdf file which consists
				// the MM context and PDP contexts of the MS subscribers
				
				HLRListPtr = op_prg_gdf_read ("HLR");
				
				/* determine how many entries the file consists */
				numRows = op_prg_list_size(HLRListPtr);
				
				for (i=0; i < numRows; i++)
					{
					// obtain a list of the columnar fields in each row
					subscribedInfoListPtr = op_prg_str_decomp(op_prg_list_access(HLRListPtr, i), ",");
					
					// extract the values of the two fields, and put them into state variables
					imsi = atoi(op_prg_list_access (subscribedInfoListPtr,0));
					apn = op_prg_list_access (subscribedInfoListPtr,1);
					qosReliablityClass = atoi(op_prg_list_access (subscribedInfoListPtr,2));
					qosDelayClass = atoi(op_prg_list_access (subscribedInfoListPtr,3));
					qosPrecedenceClass = atoi(op_prg_list_access (subscribedInfoListPtr,4));
					qosPeakBitRate = atoi(op_prg_list_access (subscribedInfoListPtr,5));
					qosMeanBitRate = atoi(op_prg_list_access (subscribedInfoListPtr,6));
					pdpType = atoi(op_prg_list_access (subscribedInfoListPtr,7));
					pdpAddress = op_prg_list_access (subscribedInfoListPtr,8);
					
					msRecordArray[imsi].isSet = 1;
					
					qosSubscribedStruct.reliabilityClass = qosReliablityClass;
					qosSubscribedStruct.delayClass = qosDelayClass;
					qosSubscribedStruct.precedenceClass = qosPrecedenceClass;
					qosSubscribedStruct.peakBitRate = qosPeakBitRate;
					qosSubscribedStruct.meanBitRate = qosMeanBitRate;
					msRecordArray[imsi].qosSubscribed = qosSubscribedStruct;
					
					memset(pdpAddressStruct.pdpAddressValue, '\0', 16);
					pdpAddressStruct.pdpType = pdpType;
					strncpy(pdpAddressStruct.pdpAddressValue, pdpAddress, strlen(pdpAddress)+1);
					msRecordArray[imsi].pdpAddress = pdpAddressStruct;
					
					memset(apnStruct.apnNetworkID, '\0', 64);
					strncpy(apnStruct.apnNetworkID, apn, strlen(apn)+1);
					msRecordArray[imsi].apn = apnStruct;
					
					/*
					sprintf (debugStr, "Retrieve HLR Record %d. IMSI %d", i, imsi);
				    op_prg_odb_print_major ("Debug message for Internal HLR", debugStr, OPC_NIL);
					sprintf (debugStr, "Retrieve HLR Record %d. APN %s", i, msRecordArray[imsi].apn.apnNetworkID);
				    op_prg_odb_print_major ("Debug message for Internal HLR", debugStr, OPC_NIL);
					sprintf (debugStr, "Retrieve HLR Record %d. QoS Reliability %d", i, msRecordArray[imsi].qosSubscribed.reliabilityClass);
				    op_prg_odb_print_major ("Debug message for Internal HLR", debugStr, OPC_NIL);
					sprintf (debugStr, "Retrieve HLR Record %d. QoS Delay %d", i, msRecordArray[imsi].qosSubscribed.delayClass);
				    op_prg_odb_print_major ("Debug message for Internal HLR", debugStr, OPC_NIL);
					sprintf (debugStr, "Retrieve HLR Record %d. QoS Precedence %d", i, msRecordArray[imsi].qosSubscribed.precedenceClass);
				    op_prg_odb_print_major ("Debug message for Internal HLR", debugStr, OPC_NIL);
					sprintf (debugStr, "Retrieve HLR Record %d. QoS Peak Bit Rate %d", i, msRecordArray[imsi].qosSubscribed.peakBitRate);
				    op_prg_odb_print_major ("Debug message for Internal HLR", debugStr, OPC_NIL);
					sprintf (debugStr, "Retrieve HLR Record %d. QoS Mean Bit Rate %d", i, msRecordArray[imsi].qosSubscribed.meanBitRate);
				    op_prg_odb_print_major ("Debug message for Internal HLR", debugStr, OPC_NIL);
					sprintf (debugStr, "Retrieve HLR Record %d. PDP Type %d", i, msRecordArray[imsi].pdpAddress.pdpType);
				    op_prg_odb_print_major ("Debug message for Internal HLR", debugStr, OPC_NIL);
					sprintf (debugStr, "Retrieve HLR Record %d. PDP Address %s", i, msRecordArray[imsi].pdpAddress.pdpAddressValue);
				    op_prg_odb_print_major ("Debug message for Internal HLR", debugStr, OPC_NIL);
					*/
					
					
					// deallocate the subscribedInfo list contents and list
					op_prg_list_free(subscribedInfoListPtr);
					op_prg_mem_free(subscribedInfoListPtr);
					}
				// deallocate the internal HLR list contents and list
				op_prg_list_free(HLRListPtr);
				op_prg_mem_free(HLRListPtr);
				}
				FSM_PROFILE_SECTION_OUT (state0_enter_exec)

			/** state (INIT) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "INIT", "hlr_process_model [INIT exit execs]")
				FSM_PROFILE_SECTION_IN ("hlr_process_model [INIT exit execs]", state0_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state0_exit_exec)


			/** state (INIT) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "INIT", "IDLE")
				/*---------------------------------------------------------*/



			/** state (IDLE) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, "IDLE", state1_enter_exec, "hlr_process_model [IDLE enter execs]")
				FSM_PROFILE_SECTION_IN ("hlr_process_model [IDLE enter execs]", state1_enter_exec)
				{
				context = 0;
				}
				FSM_PROFILE_SECTION_OUT (state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,"hlr_process_model")


			/** state (IDLE) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "IDLE", "hlr_process_model [IDLE exit execs]")
				FSM_PROFILE_SECTION_IN ("hlr_process_model [IDLE exit execs]", state1_exit_exec)
				{
				intrpt_type = op_intrpt_type ();
				if (intrpt_type == OPC_INTRPT_STRM) {
					pkptr = op_pk_get(op_intrpt_strm());
					op_pk_nfd_get(pkptr, "messageType", &messageType);
					switch (messageType) {
						case MAP_OPEN_IND:
							op_pk_nfd_get(pkptr, "appContext", &appContext);
							context = appContext;
							break;
						case MAP_OPEN_CNF:
							op_pk_nfd_get(pkptr, "appContext", &appContext);
							op_pk_nfd_get(pkptr, "result", &result);
							break;
						case MAP_CLOSE_IND:
						case MAP_P_ABORT_IND:
							break;
						default:
							break;
					}
				}
				}
				FSM_PROFILE_SECTION_OUT (state1_exit_exec)


			/** state (IDLE) transition processing **/
			FSM_PROFILE_SECTION_IN ("hlr_process_model [IDLE trans conditions]", state1_trans_conds)
			FSM_INIT_COND (OPENING)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("IDLE")
			FSM_PROFILE_SECTION_OUT (state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 3, state3_enter_exec, ;, "OPENING", "", "IDLE", "OPEN")
				FSM_CASE_TRANSIT (1, 1, state1_enter_exec, ;, "default", "", "IDLE", "IDLE")
				}
				/*---------------------------------------------------------*/



			/** state (UPDATE_LOCATION) enter executives **/
			FSM_STATE_ENTER_FORCED (2, "UPDATE_LOCATION", state2_enter_exec, "hlr_process_model [UPDATE_LOCATION enter execs]")
				FSM_PROFILE_SECTION_IN ("hlr_process_model [UPDATE_LOCATION enter execs]", state2_enter_exec)
				{
				APN *apnStructPtr;
				QoS *qosSubscribedStructPtr;
				PDPAddress *pdpAddressStructPtr;
				
				// retrieve the IMSI from the request which is
				// the key for the Internal HLR database
				// Note: IMSI is the index to the state variable: msStructArray
				
				op_pk_nfd_get (pkptr, "imsi", &imsi);
				
				// reply SGSN with the search result
				
				if (msRecordArray[imsi].isSet == 0) {
					result = RECORD_NOT_FOUND;
					map_insert_sbsr_data_req_pkptr = op_pk_create_fmt ("MAP_INSERT_SUBSCRIBER_DATA_req");
				    op_pk_nfd_set(map_insert_sbsr_data_req_pkptr, "result", result);
					op_pk_nfd_set(map_insert_sbsr_data_req_pkptr, "imsi", imsi);
					op_pk_send(map_insert_sbsr_data_req_pkptr, HLR_OUT_STRM);
				} else {
					result = RECORD_FOUND;
					map_insert_sbsr_data_req_pkptr = op_pk_create_fmt ("MAP_INSERT_SUBSCRIBER_DATA_req");
				    op_pk_nfd_set(map_insert_sbsr_data_req_pkptr, "result", result);
					op_pk_nfd_set(map_insert_sbsr_data_req_pkptr, "imsi", imsi);
					
					// allocate a new data structure for APN
					apnStructPtr = (APN *) op_prg_mem_alloc (sizeof (APN));
				    // set the apn value
				    strncpy(apnStructPtr->apnNetworkID, msRecordArray[imsi].apn.apnNetworkID, 
						strlen(msRecordArray[imsi].apn.apnNetworkID)+1);
				       
					// assign the data structure to apn field in the packet
				    op_pk_nfd_set(map_insert_sbsr_data_req_pkptr, "apn", apnStructPtr,
				        op_prg_mem_copy_create, op_prg_mem_free, sizeof (APN));
					
					// allocate a new data structure for PDP Address
					pdpAddressStructPtr = (PDPAddress *) op_prg_mem_alloc (sizeof (PDPAddress));
				    
					// set the pdpAddress value
				    strncpy(pdpAddressStructPtr->pdpAddressValue, msRecordArray[imsi].pdpAddress.pdpAddressValue, 
						strlen(msRecordArray[imsi].pdpAddress.pdpAddressValue)+1);
					// set the pdpAddress type
					pdpAddressStructPtr->pdpType = msRecordArray[imsi].pdpAddress.pdpType;
				       
					// assign the data structure to pdpAddress field in the packet
				    op_pk_nfd_set(map_insert_sbsr_data_req_pkptr, "pdpAddress", pdpAddressStructPtr,
				        op_prg_mem_copy_create, op_prg_mem_free, sizeof (PDPAddress));
					
					// allocate a new data structure for QoS Subscribed
					qosSubscribedStructPtr = (QoS *) op_prg_mem_alloc (sizeof (QoS));
				    // set the attribute of the QoS subscribed
					qosSubscribedStructPtr->reliabilityClass = msRecordArray[imsi].qosSubscribed.reliabilityClass;
					qosSubscribedStructPtr->delayClass = msRecordArray[imsi].qosSubscribed.delayClass;
					qosSubscribedStructPtr->precedenceClass = msRecordArray[imsi].qosSubscribed.precedenceClass;
					qosSubscribedStructPtr->peakBitRate = msRecordArray[imsi].qosSubscribed.peakBitRate;
					qosSubscribedStructPtr->meanBitRate = msRecordArray[imsi].qosSubscribed.meanBitRate;
					
					// assign the data structure to qos field in the packet
				    op_pk_nfd_set(map_insert_sbsr_data_req_pkptr, "qos", qosSubscribedStructPtr,
				        op_prg_mem_copy_create, op_prg_mem_free, sizeof (QoS));
					op_pk_send(map_insert_sbsr_data_req_pkptr, HLR_OUT_STRM);
				}
				
				}
				FSM_PROFILE_SECTION_OUT (state2_enter_exec)

			/** state (UPDATE_LOCATION) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "UPDATE_LOCATION", "hlr_process_model [UPDATE_LOCATION exit execs]")
				FSM_PROFILE_SECTION_IN ("hlr_process_model [UPDATE_LOCATION exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state2_exit_exec)


			/** state (UPDATE_LOCATION) transition processing **/
			FSM_TRANSIT_FORCE (3, state3_enter_exec, ;, "default", "", "UPDATE_LOCATION", "OPEN")
				/*---------------------------------------------------------*/



			/** state (OPEN) enter executives **/
			FSM_STATE_ENTER_UNFORCED (3, "OPEN", state3_enter_exec, "hlr_process_model [OPEN enter execs]")
				FSM_PROFILE_SECTION_IN ("hlr_process_model [OPEN enter execs]", state3_enter_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state3_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (7,"hlr_process_model")


			/** state (OPEN) exit executives **/
			FSM_STATE_EXIT_UNFORCED (3, "OPEN", "hlr_process_model [OPEN exit execs]")
				FSM_PROFILE_SECTION_IN ("hlr_process_model [OPEN exit execs]", state3_exit_exec)
				{
				finished = 0;
				Packet* map_open_res_pkptr;
				intrpt_type = op_intrpt_type ();
				if (intrpt_type == OPC_INTRPT_STRM) {
					pkptr = op_pk_get(op_intrpt_strm());
					op_pk_nfd_get(pkptr, "messageType", &messageType);
					switch (messageType) {
						// MAP specific indications
						case MAP_UPDATE_GPRS_LOCATION_IND:
						case MAP_INSERT_SUBSCRIBER_DATA_IND:
						case MAP_CANCEL_LOCATION_IND: 
						case MAP_PURGE_MS_IND:
						case MAP_SEND_AUTHENTICATION_INFO_IND:
						case MAP_DELETE_SUBSCRIBER_DATA_IND:
						case MAP_RESET_IND:
						case MAP_SEND_ROUTING_INFO_FOR_GPRS_IND:
						case MAP_FAILURE_REPORT_IND:
						case MAP_NOTE_MS_PRESENT_FOR_GPRS_IND:
							map_open_res_pkptr = op_pk_create_fmt("MAP_OPEN_res");
							op_pk_nfd_set(map_open_res_pkptr, "result", DIALOGUE_ACCEPTED);
							op_pk_send(map_open_res_pkptr, HLR_OUT_STRM);
							break;
						// MAP specific confirmations
						case MAP_INSERT_SUBSCRIBER_DATA_CNF:
							map_update_gprs_loc_res_pkptr = op_pk_create_fmt ("MAP_UPDATE_GPRS_LOCATION_res");
							op_pk_send(map_update_gprs_loc_res_pkptr, HLR_OUT_STRM);
							map_close_req_pkptr = op_pk_create_fmt ("MAP_CLOSE_req");
							op_pk_send_delayed(map_close_req_pkptr, HLR_OUT_STRM, 0.01);
							finished = 1;
							break;
						case MAP_CANCEL_LOCATION_CNF:
						case MAP_PURGE_MS_CNF:
						case MAP_UPDATE_GPRS_LOCATION_CNF:
						case MAP_SEND_AUTHENTICATION_INFO_CNF:
						case MAP_DELETE_SUBSCRIBER_DATA_CNF:
						case MAP_SEND_ROUTING_INFO_FOR_GPRS_CNF:
						case MAP_FAILURE_REPORT_CNF:
						case MAP_NOTE_MS_PRESENT_FOR_GPRS_CNF:
							finished = 1;
							break;
						case MAP_CLOSE_IND:
						case MAP_P_ABORT_IND:
							finished = 1;
							break;		
						case MAP_OPEN_IND:
							map_open_res_pkptr = op_pk_create_fmt("MAP_OPEN_res");
							op_pk_nfd_set(map_open_res_pkptr, "result", DIALOGUE_REFUSED);
							op_pk_send(map_open_res_pkptr, HLR_OUT_STRM);
							break;
						case MAP_DELIMITER:
							break;
						default:
							break;
					}
				}
				}
				FSM_PROFILE_SECTION_OUT (state3_exit_exec)


			/** state (OPEN) transition processing **/
			FSM_PROFILE_SECTION_IN ("hlr_process_model [OPEN trans conditions]", state3_trans_conds)
			FSM_INIT_COND (FINISHED)
			FSM_TEST_COND (UPDATE_LOCATION_IND_RCVD)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("OPEN")
			FSM_PROFILE_SECTION_OUT (state3_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 1, state1_enter_exec, ;, "FINISHED", "", "OPEN", "IDLE")
				FSM_CASE_TRANSIT (1, 2, state2_enter_exec, ;, "UPDATE_LOCATION_IND_RCVD", "", "OPEN", "UPDATE_LOCATION")
				FSM_CASE_TRANSIT (2, 3, state3_enter_exec, ;, "default", "", "OPEN", "OPEN")
				}
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,"hlr_process_model")
		}
	}




void
hlr_process_model_diag (OP_SIM_CONTEXT_ARG_OPT)
	{
	/* No Diagnostic Block */
	}




void
hlr_process_model_terminate (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = __LINE__;
#endif

	FIN_MT (hlr_process_model_terminate ())

	Vos_Poolmem_Dealloc_MT (OP_SIM_CONTEXT_THREAD_INDEX_COMMA pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in hlr_process_model_svar function. */
#undef debugStr
#undef msRecordArray
#undef context

#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE

#define FIN_PREAMBLE_DEC
#define FIN_PREAMBLE_CODE

VosT_Obtype
hlr_process_model_init (int * init_block_ptr)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	VosT_Obtype obtype = OPC_NIL;
	FIN_MT (hlr_process_model_init (init_block_ptr))

	Vos_Define_Object (&obtype, "proc state vars (hlr_process_model)",
		sizeof (hlr_process_model_state), 0, 20);
	*init_block_ptr = 0;

	FRET (obtype)
	}

VosT_Address
hlr_process_model_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype obtype, int init_block)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	hlr_process_model_state * ptr;
	FIN_MT (hlr_process_model_alloc (obtype))

	ptr = (hlr_process_model_state *)Vos_Alloc_Object_MT (VOS_THREAD_INDEX_COMMA obtype);
	if (ptr != OPC_NIL)
		ptr->_op_current_block = init_block;
	FRET ((VosT_Address)ptr)
	}



void
hlr_process_model_svar (void * gen_ptr, const char * var_name, void ** var_p_ptr)
	{
	hlr_process_model_state		*prs_ptr;

	FIN_MT (hlr_process_model_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (void *)OPC_NIL;
		FOUT
		}
	prs_ptr = (hlr_process_model_state *)gen_ptr;

	if (strcmp ("debugStr" , var_name) == 0)
		{
		*var_p_ptr = (void *) (prs_ptr->debugStr);
		FOUT
		}
	if (strcmp ("msRecordArray" , var_name) == 0)
		{
		*var_p_ptr = (void *) (prs_ptr->msRecordArray);
		FOUT
		}
	if (strcmp ("context" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->context);
		FOUT
		}
	*var_p_ptr = (void *)OPC_NIL;

	FOUT
	}

