/* Process model C form file: mjohanss_pc_prio.pr.c */
/* Portions of this file copyright 1992-2003 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
const char mjohanss_pc_prio_pr_c [] = "MIL_3_Tfile_Hdr_ 100A 30A op_runsim 7 40E364A4 40E364A4 1 hermes rsn 0 0 none none 0 0 none 0 0 0 0 0 0 0 0 90b 2                                                                                                                                                                                                                                                                                                                                                                                                              ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>



/* Header Block */

#define BUF_TO_LOWERLAYER 0
#define MUX_TO_BUF 0

#define ARRIVAL     op_intrpt_type () == OPC_INTRPT_STRM
#define SERVICE     op_intrpt_type () == OPC_INTRPT_ACCESS



/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(_op_last_line_passed) = __LINE__ - _op_block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(_op_last_line_passed) = 0; _op_block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	} mjohanss_pc_prio_state;

#define pr_state_ptr            		((mjohanss_pc_prio_state*) (OP_SIM_CONTEXT_PTR->mod_state_ptr))

/* These macro definitions will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE
#if defined (OPD_PARALLEL)
#  define FIN_PREAMBLE_DEC	mjohanss_pc_prio_state *op_sv_ptr; OpT_Sim_Context * tcontext_ptr;
#  define FIN_PREAMBLE_CODE	\
		if (VosS_Mt_Perform_Lock) \
			VOS_THREAD_SPECIFIC_DATA_GET (VosI_Globals.simi_mt_context_data_key, tcontext_ptr, SimT_Context *); \
		else \
			tcontext_ptr = VosI_Globals.simi_sequential_context_ptr; \
		op_sv_ptr = ((mjohanss_pc_prio_state *)(tcontext_ptr->mod_state_ptr));
#else
#  define FIN_PREAMBLE_DEC	mjohanss_pc_prio_state *op_sv_ptr;
#  define FIN_PREAMBLE_CODE	op_sv_ptr = pr_state_ptr;
#endif


/* No Function Block */


#if !defined (VOSD_NO_FIN)
enum { _op_block_origin = __LINE__ };
#endif

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void mjohanss_pc_prio (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Obtype mjohanss_pc_prio_init (int * init_block_ptr);
	VosT_Address mjohanss_pc_prio_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype, int);
	void mjohanss_pc_prio_diag (OP_SIM_CONTEXT_ARG_OPT);
	void mjohanss_pc_prio_terminate (OP_SIM_CONTEXT_ARG_OPT);
	void mjohanss_pc_prio_svar (void *, const char *, void **);


	VosT_Fun_Status Vos_Define_Object (VosT_Obtype * _op_obst_ptr, const char * _op_name, unsigned int _op_size, unsigned int _op_init_obs, unsigned int _op_inc_obs);
	VosT_Address Vos_Alloc_Object_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype _op_ob_hndl);
	VosT_Fun_Status Vos_Poolmem_Dealloc_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Address _op_ob_ptr);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
mjohanss_pc_prio (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	FIN_MT (mjohanss_pc_prio ());
	if (1)
		{
		Packet          *pkptr;


		FSM_ENTER ("mjohanss_pc_prio")

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (INS_PRIO) enter executives **/
			FSM_STATE_ENTER_UNFORCED (0, "INS_PRIO", state0_enter_exec, "mjohanss_pc_prio [INS_PRIO enter execs]")
				FSM_PROFILE_SECTION_IN ("mjohanss_pc_prio [INS_PRIO enter execs]", state0_enter_exec)
				{
				/* a new packet has arrived; acquire it */
				pkptr = op_pk_get (op_intrpt_strm ());
				
				/* insert the new packet according to priority in subqueue 0 */
				if (op_subq_pk_insert (0, pkptr, OPC_QPOS_PRIO) != OPC_QINS_OK)
					{
					/* if the insertion failed, discard the packet */
					op_pk_destroy (pkptr);
					printf("MUX_PRIO_QUEUE: insert packet FAILED\n");
					}
				//printf("MUX_PRIO_QUEUE: packet inserted\n");
				}
				FSM_PROFILE_SECTION_OUT (state0_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (1,"mjohanss_pc_prio")


			/** state (INS_PRIO) exit executives **/
			FSM_STATE_EXIT_UNFORCED (0, "INS_PRIO", "mjohanss_pc_prio [INS_PRIO exit execs]")
				FSM_PROFILE_SECTION_IN ("mjohanss_pc_prio [INS_PRIO exit execs]", state0_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state0_exit_exec)


			/** state (INS_PRIO) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "INS_PRIO", "BRANCH")
				/*---------------------------------------------------------*/



			/** state (SEND_HEAD) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, "SEND_HEAD", state1_enter_exec, "mjohanss_pc_prio [SEND_HEAD enter execs]")
				FSM_PROFILE_SECTION_IN ("mjohanss_pc_prio [SEND_HEAD enter execs]", state1_enter_exec)
				{
				/* a request has been made to access the queue */
				/* check if its empty */
				if (!op_subq_empty (0))
				    {
				    /* access the first packet in the subqueue */
				    pkptr = op_subq_pk_remove (0, OPC_QPOS_HEAD);
				
					/* forward it to the destination */
					//printf("MUX_PRIO_QUEUE: Packet forwarded\n");
				    op_pk_send (pkptr, BUF_TO_LOWERLAYER);
				    }
				}
				FSM_PROFILE_SECTION_OUT (state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,"mjohanss_pc_prio")


			/** state (SEND_HEAD) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "SEND_HEAD", "mjohanss_pc_prio [SEND_HEAD exit execs]")
				FSM_PROFILE_SECTION_IN ("mjohanss_pc_prio [SEND_HEAD exit execs]", state1_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state1_exit_exec)


			/** state (SEND_HEAD) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "SEND_HEAD", "BRANCH")
				/*---------------------------------------------------------*/



			/** state (BRANCH) enter executives **/
			FSM_STATE_ENTER_FORCED (2, "BRANCH", state2_enter_exec, "mjohanss_pc_prio [BRANCH enter execs]")
				FSM_PROFILE_SECTION_IN ("mjohanss_pc_prio [BRANCH enter execs]", state2_enter_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state2_enter_exec)

			/** state (BRANCH) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "BRANCH", "mjohanss_pc_prio [BRANCH exit execs]")
				FSM_PROFILE_SECTION_IN ("mjohanss_pc_prio [BRANCH exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state2_exit_exec)


			/** state (BRANCH) transition processing **/
			FSM_PROFILE_SECTION_IN ("mjohanss_pc_prio [BRANCH trans conditions]", state2_trans_conds)
			FSM_INIT_COND (SERVICE)
			FSM_TEST_COND (ARRIVAL)
			FSM_TEST_LOGIC ("BRANCH")
			FSM_PROFILE_SECTION_OUT (state2_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 1, state1_enter_exec, ;, "SERVICE", "", "BRANCH", "SEND_HEAD")
				FSM_CASE_TRANSIT (1, 0, state0_enter_exec, ;, "ARRIVAL", "", "BRANCH", "INS_PRIO")
				}
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (2,"mjohanss_pc_prio")
		}
	}




void
mjohanss_pc_prio_diag (OP_SIM_CONTEXT_ARG_OPT)
	{
	/* No Diagnostic Block */
	}




void
mjohanss_pc_prio_terminate (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = __LINE__;
#endif

	FIN_MT (mjohanss_pc_prio_terminate ())

	Vos_Poolmem_Dealloc_MT (OP_SIM_CONTEXT_THREAD_INDEX_COMMA pr_state_ptr);

	FOUT
	}


#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE

#define FIN_PREAMBLE_DEC
#define FIN_PREAMBLE_CODE

VosT_Obtype
mjohanss_pc_prio_init (int * init_block_ptr)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	VosT_Obtype obtype = OPC_NIL;
	FIN_MT (mjohanss_pc_prio_init (init_block_ptr))

	Vos_Define_Object (&obtype, "proc state vars (mjohanss_pc_prio)",
		sizeof (mjohanss_pc_prio_state), 0, 20);
	*init_block_ptr = 4;

	FRET (obtype)
	}

VosT_Address
mjohanss_pc_prio_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype obtype, int init_block)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	mjohanss_pc_prio_state * ptr;
	FIN_MT (mjohanss_pc_prio_alloc (obtype))

	ptr = (mjohanss_pc_prio_state *)Vos_Alloc_Object_MT (VOS_THREAD_INDEX_COMMA obtype);
	if (ptr != OPC_NIL)
		ptr->_op_current_block = init_block;
	FRET ((VosT_Address)ptr)
	}



void
mjohanss_pc_prio_svar (void * gen_ptr, const char * var_name, void ** var_p_ptr)
	{

	FIN_MT (mjohanss_pc_prio_svar (gen_ptr, var_name, var_p_ptr))

	*var_p_ptr = (void *)OPC_NIL;

	FOUT
	}

